=begin
 * Name: SiSU - Simple information Structuring Universe - Structured information, Serialized Units
 * Author: Ralph@Amissah.com
   * http://www.jus.uio.no/sisu
   * http://www.jus.uio.no/sisu/SiSU/download
 * Description: Document skin for SiSU descriptive pages, ... 
 * arch-tag: skin for an individual document set (sisu)
 * License: GPL 2 or later
 * $Date$
 * $Id$
 * Notes: Site default appearance variables set in defaults.rb
     Generic site wide modifications set here scribe_skin.rb, and this file required by other "scribes" instead of defaults.rb
=end
module SiSU_Viz
  require "#{SiSU_lib}/defaults"
	include SiSU_Viz
  class Path
    def root
      './sisu/'                                                                  # the only parameter that cannot be changed here
    end
    def rel
      '../'
    end
  end
  class Url
    def home
      'http://www.jus.uio.no/sisu/'
    end
    def site                                                                     # used in pdf header
      'http://www.jus.uio.no/sisu' 
    end
    def txt                                                                      # text to go with url usually stripped url
      'www.jus.uio.no/sisu/'
    end
    def home_url
      '../index.html'
    end
    #def root_http
      #root server path info, used in document information
    #end
  end
  class Color
    def band1
      '"#ffffff"'      
    end
    def band2
      '"#ffffff"'
    end
  end
  class Txt
    def hp
    	%{&nbsp;SiSU}
    end
    def home
      #"www.jus.uio.no/sisu/" 
      'SiSU' 
    end
  end
  class Icon
    def home_button
      'sisu.home.png'
    end
    def home_banner
      self.home_button
    end
  end
  class Banner
    def home_button
		  %{<table summary="home button" border="0" cellpadding="3" cellspacing="0"><tr><td align="left" bgcolor="#ffffff"><a href="#{@url.site}/">#{@png.home}</a></td></tr></table>\n}
    end
    def home_and_index_buttons
	    %{<table><tr><td width="20%"><table summary="home and index buttons" border="0" cellpadding="3" cellspacing="0"><tr><td align="left" bgcolor="#ffffff"><a href="#{@url.site}/" target="_top">#{@png.home}</a>#{@table.close}</td><td width="60%"><center><center><table summary="buttons" border="1" cellpadding="3" cellspacing="0"><tr><td align="center" bgcolor="#ffffff"><font face="arial" size="2"><a href="toc" target="_top">&nbsp;This&nbsp;text&nbsp;sub-&nbsp;<br />&nbsp;Table&nbsp;of&nbsp;Contents&nbsp;</a></font>#{@table.close}</center></center></td><td width="20%">&nbsp;#{@table.close}}
    end
    def band
      %{<table summary="band" border="0" cellpadding="3" cellspacing="0"><tr><td align="left" bgcolor="#ffffff"><a href="#{@url.site}/" target="_top">#{@png.home}</a>#{@table.close}}
    end
    def home_guide
    end
  end
  class Credits
    def credits
      %{<center><table summary="credits" align="center"bgcolor="#ffffff"><tr><td>#{@widget.sisu}#{@widget.wayBetter}#{@widget.browsers}#{@widget.pdfviewers}</td></tr></table></center>}
    end
  end
  class Tex
    def header_center
	    "\\chead{\\href{#{@url.site}/}{www.jus.uio.no/sisu/}}"
    end
    def home_url
	    "\\href{#{@url.site}/}{www.jus.uio.no/sisu/}"
    end
    def home
	    "\\href{#{@url.site}/}{Ralph Amissah}"
    end
    def owner_chapter
      "Document owner details"
    end
  end
  class Stamp
    def stmp
  	  "\\copyright Ralph Amissah, released under the GPL \\\\\n ralph@amissah.com \\\\\n www.jus.uio.no/sisu/"
    end
  end
  class Home
    def redirect
      <<WOK
<html><head>
  <title>SiSU</title>
  <meta http-equiv="refresh" content="0, url=http://www.jus.uio.no/sisu">
</head>
<body>
  SiSU informtion provided at <a href="http://www.jus.uio.no/sisu">www.jus.uio.no/sisu</a><p />
  If your browser supports redirection, you will be escorted there shortly.
</body>
</html>
WOK
    end
#    def index #place your home page here
#      <<WOK
#WOK
#    end
    def redirect
      <<WOK
<html><head>
<title>SiSU</title>
<meta http-equiv="refresh" content="0, url=http://www.jus.uio.no/sisu/SiSU/">
</head>
<body>
SiSU informtion provided at <a href="http://www.jus.uio.no/sisu/SiSU/">www.jus.uio.no/sisu/SiSU</a><p />
If your browser supports redirection, you will be escorted there shortly.
</body>
</html>
WOK
    end
  end
end

