=begin
 * Name: SiSU - Simple information Structuring Universe - Structured information, Serialized Units
 * Author: Ralph Amissah
   * http://www.jus.uio.no/sisu
   * http://www.jus.uio.no/sisu/SiSU/download

 * Description: online help
   * $Id$
 * Copyright (C) 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005 Ralph Amissah

 * License: GPL 2 or later

  Summary of GPL 2

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along
  with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA

  If you have Internet connection, the latest version of the GPL should be
  available at these locations:
    http://www.fsf.org/licenses/gpl.html
    http://www.gnu.org/copyleft/gpl.html
    http://www.jus.uio.no/sisu/gpl2.fsf

  SiSU was first released to the public on January 4th 2005

  SiSU uses:
  
  *  Standard SiSU markup syntax,
  *  Standard SiSU meta-markup syntax, and the
  *  Standard SiSU object citation numbering and system
  
  © Ralph Amissah 1997, current 2005.
  All Rights Reserved.

 * Ralph Amissah: ralph@amissah.com
                  ralph.amissah@gmail.com
=end
module SiSU_Help
  require "#{SiSU_lib}/sysenv"
  require "#{SiSU_lib}/param"
  include SiSU_Screen
  class Help
    def initialize(request='',fns=nil)
      @request=request
      p request
      @cX=SiSU_Screen::Ansi.new('yes').cX #@cX=@@cX
      #@cX=SiSU_Screen::Ansi.new('c').cX #@cX=@@cX
      @fns=fns||'dummy_file_ref.sst'
      @dir=SiSU_Env::Info_dir.new(@fns)
      @db=SiSU_Env::Info_db.new
      m=/.+\/(\S+)/im
      @output_stub=Dir.pwd[m, 1]
    end
    def help_request
      begin
        gotten=nil
        regx=/(list|com(?:mands)?|markup|syntax|example|head(?:ers?)?|headings?|endnotes|tables?|customise|skin|dir(?:ectories)?|paths?|lang(?:uage)?|db|sql|modules|setup|conf(?:ig(?:ure)?)?|standards?|li[cs]en[sc]e|scratch|install|termsheet|dublin(?:core)?|dc|customise|styles?|appearance|theme|dir(ector(y|ies))?|metaverse|html|css|php|pdf|latex|tex|(?:tex)?info|abstract|features|summary|shortcuts?|sisu|about|ext(?:ernal)?(?:_?prog(?:rams)?)?)/
      inf=%{#{@cX.blue}sisu help#{@cX.off} #{@cX.cyan}type keyword else "enter" to exit help:\n\tkeywords include:#{@cX.off} #{@cX.brown}list, commands, shortcuts, markup, syntax, headers, headings, endnotes, tables, example, customise, skin, directories, path, language, db, modules, install, setup, configure, external_programs, dublincore, termsheet, features, external_programs, license, exit#{@cX.off}\n#{@cX.blue_hi}SiSU help#{@cX.off} #{@cX.ruby}~#{@cX.off} }
        print inf
        until gotten =~/exit|quit|bye|q|^\s*$/ and @request.empty? #or @request =~/exit$/
          @help=Help.new(@request)
          if @request
            gotten=@request
            @request=nil
          end
          #exit if gotten=~/exit|quit|bye|q|^\s*$/ #and @request !~/\S+/
          #{ help instructions
          case gotten
          when /h((?:elp)| )|~/i
            @help.summary
            help_@request
          when /list/i:                                 @help.summary
          when /com(mands)?/i:                          @help.commands
          when /markup|syntax/i:                        @help.markup
          when /example/i:                              @help.example
          when /headings?/i:                            @help.headings
          when /head(ers?)?/i:                          @help.headers
          when /dublin(core)?|dc/i:                     @help.dublinCore
          when /endnotes/i:                             @help.endnotes
          when /tables?/i:                              @help.tables
          when /customise|skin/i:                       @help.customise
          when /modules/i:                              @help.modules
          when /dir(ector(y|ies))?/i:                   @help.directories
          when /paths?/i:                               @help.path
          when /setup/i:                                @help.setup
          when /conf(?:ig(?:ure)?)?/i:                  @help.configure
          when /standards?/i:                           @help.standards
          when /lang(?:uage)?/i:                        @help.languages
          when /li[cs]en[sc]e/i:                        @help.license
          when /scratch/i:                              @help.scratch
          when /install/i:                              @help.install
          when /termsheet/i:                            @help.termsheet
          when /customise|styles?|appearance|theme/i:   @help.customise
          when /db|sql/i:                               @help.sql
          when /metaverse/i:                            @help.metaverse
          when /html|css/i:                             @help.html
          when /php/i:                                  @help.php
          when /pdf|latex|tex/i:                        @help.pdf
          when /(tex)?info/i:                           @help.texinfo
          when /lout/i:                                 @help.lout
          when /tests?/i:                               @help.tests
          when /abstract|features|summary|about|sisu/i: @help.abstract
          when /ext(?:ernal)?(?:_?prog(?:rams)?)?/:     @help.external_programs
          when /shortcuts?/i:                           @help.shortcuts
          when /ansi|colors?/i:                         Ansi.new('c').colors
          else                                          @help.summary
          end
          print inf
          gotten=nil
          gotten=gets 
          #p gotten
          #exit if gotten=~/exit|quit|bye|q|^\s*$/ #and @request !~/\S+/
        end
      rescue
        #STDERR.puts Ansi.new($!, $@).rescue
        # dies silently... for now, silence of use in connection with "sisu ~ commands" etc.
      ensure
      end
    end
    def summary
      print <<WOK
if you have not done so, typing sisu on its own or "sisu help", should give you this sisu help summary and the sisu (interactive help mode) help promt, from which help on each keyword can be obtained.

alternatively typing #{@cX.orange}sisu help#{@cX.off} #{@cX.green}[keyword]#{@cX.off} at the command prompt will provide the sisu help page requested and return to the command prompt (if nothing is found it will print this page and return to the command prompt)

  Keywords (related to using SiSU)
      #{@cX.green}help#{@cX.off} or #{@cX.green}list#{@cX.off}   this sisu help summary
      #{@cX.green}commands#{@cX.off}       sisu help commands
    ------------------------------------------
    Preparing Documents for SiSU
      #{@cX.green}markup#{@cX.off}         sisu help markup     (an incomplete overview)
      #{@cX.green}headers#{@cX.off}        sisu help headers    (document-wide instructions)
      #{@cX.green}headings#{@cX.off}       sisu help headings   (document structure, headings, tables of contents)
      #{@cX.green}endnotes#{@cX.off}       sisu help endnotes
      #{@cX.green}tables#{@cX.off}         sisu help tables
      #{@cX.green}example#{@cX.off}        sisu help example
      #{@cX.cyan}sisu_convert#{@cX.off}   program for initial (very basic and partial) conversion to sisu file format (html and word97 supported)
    ------------------------------------------
    Customising/Modifying SiSU
      #{@cX.green}customise#{@cX.off}      sisu help customise
      #{@cX.green}modules#{@cX.off}        sisu help modules
    ------------------------------------------
    Installing SiSU
      #{@cX.green}install#{@cX.off}        sisu help install
      #{@cX.green}setup#{@cX.off}          sisu help setup
    ------------------------------------------
    SiSU some tests
      #{@cX.green}tests#{@cX.off}          sisu help tests
    ------------------------------------------
    SiSU's License
      #{@cX.green}license#{@cX.off}        sisu help license
WOK
  end
  def abstract
    print <<WOK
Features:
#{@cX.cyan}(i)#{@cX.off} minimal markup requirement
#{@cX.cyan}(ii)#{@cX.off} single file marked up for multiple outputs
#{@cX.cyan}(iii)#{@cX.off} markup is simpler than html
#{@cX.cyan}(iv)#{@cX.off} the simple syntax is mnemonic, influenced by mail/messaging/wiki markup practices
#{@cX.cyan}(v)#{@cX.off} human readable, and easily writable
#{@cX.cyan}(vi)#{@cX.off} multiple outputs include amongst others: html; pdf via LaTeX; (structured) XML; sql - currently PostgreSQL and sqlite; plaintext, (also texinfo)
#{@cX.cyan}(vii)#{@cX.off} all text objects (headings and paragraphs) are numbered identically, for citation purposes, in all outputs (html, pdf, sql etc.)
#{@cX.cyan}(viii)#{@cX.off} creates organised directory/file structure for output
#{@cX.cyan}(ix)#{@cX.off} easily mapped with its clearly defined structure, with all text objects numbered, you know in advance where in each document output type, a bit of text will be found (eg. from an sql search, you know where to go to find the prepared html output or pdf etc.)... there is more
#{@cX.cyan}(x)#{@cX.off} use of Dublin Core and other meta-tags to permit the addition of some semantic information on documents, and making easy integration of rdf/rss feeds etc.
#{@cX.cyan}(xi)#{@cX.off} very easily skinnable, document appearance on a project/site wide, or document instance level easily controlled/changed
#{@cX.cyan}(xii)#{@cX.off} in many cases a regular expression may be used (once in the document header) to define all or part of a documents structure obviating or reducing the need to provide structural markup within the document
#{@cX.cyan}(xiii)#{@cX.off} is a batch processor for handling large document sets, ... though once generated they need not be re-generated, unless changes are made to the desired presentation of a particular output type
#{@cX.cyan}(xiv)#{@cX.off} possible to pre-process, which permits the easy creation of standard form documents, and templates/term-sheets
#{@cX.cyan}(xv)#{@cX.off} extremely modular, (thanks in no small part to Ruby) another output format required, write another module....
#{@cX.cyan}(xvi)#{@cX.off} easy to update output formats (eg html, xhtml, latex/pdf produced can be updated in program and run against whole document set)
#{@cX.cyan}(xvii)#{@cX.off} easy to add, modify, or have alternative syntax rules for input, should you need to
#{@cX.cyan}(xviii)#{@cX.off} "word maps" rudimentary index, consisting of all the words in a document and their (text object) locations within the text
#{@cX.cyan}(xix)#{@cX.off} tied to revision control system, only code and marked up file need be backed up, to be sure of the much larger document set
#{@cX.cyan}(xx)#{@cX.off} syntax highlighting files for markup, primarily (g)vim so far.

SiSU was developed in relation to legal documents, and so is strong across a wide variety of texts (law, literature...), though weak on formulae/statistics, it does handle images. An assumption has been document sets that are to be preserved and maintained over time (also a result of the legal text origin). SiSU has been developed and used over a number of years, and the requirements to cover a wide range of documents have been thoroughly explored. 

There is more detailed information available on it from:
  #{@cX.blue}http://www.jus.uio.no/sisu#{@cX.off}
 *  plaintext
 *  html
 *  XML (structured)
 *  LaTeX/pdf
 *  texinfo
 *  sql (at present postgresql & sqlite)

A couple of sample inputs and outputs:

The markup for "War and Peace" (chosen because it is a large text & to test the use of SiSU on Project Gutenberg's plaintext), this is the markup, very little after the headers (there is an insert of their legal notices). Took no time at all, it is a particularly simple text to markup though
A simple document                                                              and a more demanding document
         #{@cX.blue}http://www.jus.uio.no/sisu/sample/war.and.peace.leo.tolstoy.er20      http://www.jus.uio.no/sisu/sample/autonomy.markup1.er30#{@cX.off}
Some resulting outputs:
  html   #{@cX.blue}http://www.jus.uio.no/sisu/war.and.peace.leo.tolstoy/                 http://www.jus.uio.no/sisu/autonomy.markup1/#{@cX.off}
                                                                               #{@cX.blue}http://www.jus.uio.no/sisu/autonomy.markup1/doc#{@cX.off}
  pdf    #{@cX.blue}http://www.jus.uio.no/sisu/war.and.peace.leo.tolstoy/portrait         http://www.jus.uio.no/sisu/autonomy.markup1/portrait
         #{@cX.blue}http://www.jus.uio.no/sisu/war.and.peace.leo.tolstoy/landscape        http://www.jus.uio.no/sisu/autonomy.markup1/landscape#{@cX.off}
  plaintext  #{@cX.blue}http://www.jus.uio.no/sisu/war.and.peace.leo.tolstoy/doc.txt          http://www.jus.uio.no/sisu/autonomy.markup1/doc.txt#{@cX.off}
WOK
    end
    def commands
      print <<WOK
 
 #{@cX.ruby}-A#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} produces  plaintext  with  dos  linefeeds.  Without  markup, (object numbers are omitted), has footnotes at end of each para‐ graph that contains them [ -a for equivalent Unix (ascii) output file] [see -E for endnotes]

 #{@cX.ruby}-a#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} produces plaintext  with Unix linefeeds.  Without  markup, (object numbers are omitted), has footnotes at end of each para‐ graph that contains them [ -A for equivalent dos (ascii)  output file] [see -e for endnotes]

  #{@cX.ruby}-b#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} produces xhtml/XML output for browser viewing (sax parsing)

 #{@cX.ruby}-C#{@cX.off} configure/initialise shared output directory files/force update, shared output con fig files such as css and dtd files are not updated if they  already  exist  unless
        this flag is used

 #{@cX.ruby}-CC#{@cX.off} configure/initialise  more  extensive  than  -C shared output directory files/force update, shared output config files such as css and dtd files  are  not  updated  if they already exist unless this flag is used

 #{@cX.ruby}-c#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} screen toggle ansi screen colour on or off depending on default set (unless -c flag is used: if sisurc colour default is set to ´true´, output to screen will  be  with colour,  if  sisurc  colour default is set to ´false´ or is undefined screen output will be without colour)

 #{@cX.ruby}-D#{@cX.off} #{@cX.green}[instruction]#{@cX.off} #{@cX.green}[filename]#{@cX.off} database instruction, see database section below

 #{@cX.ruby}-d#{@cX.off} #{@cX.green}[instruction]#{@cX.off} #{@cX.green}[filename]#{@cX.off} database instruction, see database section below [only -D currently available]

 #{@cX.ruby}-E#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} produces plaintext with dos linefeeds, and without markup,  endnotes follow the main text (in -a endnotes follow the paragraphs that contain them). There are no object numbers [see -e for Unix (ascii) output file] [see -A for footnotes]
 
 #{@cX.ruby}-e#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} produces plaintext with Unix linefeeds, and without markup, endnotes follow the main text. Object numbers are omitted. [ -E for equivalent dos (ascii) output file] [ -a for footnotes]
 
 #{@cX.ruby}-F#{@cX.off} generate examples of (naive) cgi  search  form  for  sqlite  and  pgsql depends  on  your already having used sisu to populate an sqlite and/or pgsql database, (the sqlite version scans the  output  directories  for existing  sisu_sqlite  databases,  so  it  is first necessary to create them, before generating the search form) see -d  -D  and  the  database section  below.   If  the optional parameter webrick is passed, the cgi examples created will be set up to use the default port set for use  by the  webrick  server,  (otherwise the port is left blank and the system setting used, usually 80). The samples are dumped in the present work directory which must be writable, (with screen instructions given that they be copied to the cgi-bin directory).

 #{@cX.ruby}-H#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} produces html (css version) (creates html (using css)), with url link suffixes (.html .pdf etc.) omitted ("Hide"). For web servers that are confireud so as not to require file extensions to locate and serve files. [behaviour switched see -h]

 #{@cX.ruby}-h#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} produces html (hardlinks i.e. with name suffixes in links/local urls).  html,  with internal document links that include the document suffix, ie whether it is .html or .pdf (required for browsing directly off a file system, and works with most web servers). [behaviour switched see -H]

 #{@cX.ruby}-I#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} produces texinfo file with its myriad of possibilities

 #{@cX.ruby}-L#{@cX.off} prints license information
 
 #{@cX.ruby}-M#{@cX.off} #{@cX.green}[filename/wildcard/url]#{@cX.off} maintenance mode, files created for processing are not deleted, and their locations are indicated

 #{@cX.ruby}-m#{@cX.off} #{@cX.green}[filename/wildcard/url]#{@cX.off} create (new)metaVerse (used in all subsequent processing). Produce a meta file, the first step in processing, and the file all subsequent processing utilize.  (Should usually be run together with other commands to ensure that the lated version of markup source document is used, i.e. add -m flag to other flags required).
 
 #{@cX.ruby}-N#{@cX.off} #{@cX.green}[filename/wildcard/url]#{@cX.off} document content certificate as md5 digest tree of document produced  (as digest.txt), the digest for the document, and digests for each object contained within  the  document  (together  with information on software versions that produced it). Try -mNV for verbose digest output to screen

 #{@cX.ruby}-n#{@cX.off} #{@cX.green}[filename/wildcard/url]#{@cX.off} skip meta-markup (building of "metaverse"), this skips the equivalent of -m

 #{@cX.ruby}-p#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} produces LaTeX pdf (portrait & landscape)

 #{@cX.ruby}-q#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} quiet, less output to screen

 #{@cX.ruby}-r#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} copies  sisu  output files to remote host using scp (default). This requires that sisurc.yaml has been provided with information on hostname and  user name, and that you have your "keys" and ssh agent in place
 
 #{@cX.ruby}-S#{@cX.off} #produces tarred and gzipped  sisu directory of markup files including sisu markup source files and the directories local configuration file,  images  and skins. Note: this only includes the configuration files or skins contained in ./_sisu not those in ~/.sisu The resulting tar gzip file has a .tgz suffix added to the markup source directory name. To tar and gzip individual files see the -Z [filename/wildcard] option.  Note: (this option is tested only with zsh)

 #{@cX.ruby}-S#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off}  produces individual specified tarred and gzipped sisu file including sisu markup source file, together with the related images and skin. The resulting tar gzip file has a .tgz suffix added to the markup source file name. The directory structure of the unzipped file is understood by sisu, and sisu commands can be run  within it. (sisu does not at present automatically unpack and run on these files, but is a convenient way of packing individual files for sending Note: if you wish to send multiple files, it quickly becomes more space efficient to tar and gzip the sisu markup directory, (without the _sisu_processing subdirectory) rather than the individual files for sending). See the -Z option without [filename/wildcard]
 
 #{@cX.ruby}-t#{@cX.off} #{@cX.green}[filename/wildcard (*.termsheet.rb)]#{@cX.off} standard form document builder, preprocessing feature

 #{@cX.ruby}-U#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} prints url list/map for the available processing flags options and resulting files that could be requested, (can be used to get a list of processing options in  relation to a file, together with information on the output that would be produced), -u provides url mapping for those flags requested for processing. The default assumes sisu_webrick is running and provides webrick url mappings where appropriate, but these can be switched to file system paths in sisurc.yaml

 #{@cX.ruby}-u#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} provides url mapping of output files for the flags requested for processing, also see -U

 #{@cX.ruby}-V#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} even more verbose than -v the -V flag provides some additional information  related to paths largely for maintenance (and preserves certain processing files that would otherwise be removed)

 #{@cX.ruby}-v#{@cX.off} on its own, provides SiSU version information.  

 #{@cX.ruby}-v#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} provides more verbose output of what is being built, where it is being  built  (and error messages if any), as with -u flag provides a url mapping of files created for each of the processing flag requests

 #{@cX.ruby}-X#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} produces XML output with deep document structure, in the nature of dom

 #{@cX.ruby}-x#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} produces XML output (sax parsing)

 #{@cX.ruby}-W#{@cX.off} #{@cX.green}[port]#{@cX.off} starts ruby´s webrick webserver, points at sisu output directories (default port is set)

 #{@cX.ruby}-w#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} produces wordmap, a rudimentary index of all the words in a document

 #{@cX.ruby}-Z#{@cX.off} Zap, if used with other processing flags #{@cX.green}deletes output files#{@cX.off} of the type about to be processed, prior to processing.  If -Z is used as  the lone  processing  related flag (or in conjunction with a combination of -[mMvVq]), will remove the related document output directory.  
 
 #{@cX.ruby}-z#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} produces php (zend) [as does processing files with .ph? suffix]

 #{@cX.ruby}-0#{@cX.off} [with -h or -H or -p] turn display of text object numbering off (implemented for html (css) and LaTeX/pdf output) [digit not uppercase o]

 #{@cX.ruby}databases#{@cX.off}

 #{@cX.ruby}dbi - database interface -D set for postgresql -d set for sqlite#{@cX.off}

 #{@cX.ruby}-D#{@cX.off} #{@cX.ruby}createall#{@cX.off} creates empty postgresql db and required tables & indexes  (rb.dbi)  [#{@cX.ruby}-P  createall#{@cX.off} using rb.psql; #{@cX.ruby}-d createall#{@cX.off} sqlite equivalent]

 #{@cX.ruby}-Di#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} or  #{@cX.ruby}-D#{@cX.off}  #{@cX.ruby}import#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} imports data specified to postgresql db (rb.dbi) [#{@cX.ruby}-P import#{@cX.off} using rb.psql; #{@cX.ruby}-d import#{@cX.off} sqlite equivalent]

 #{@cX.ruby}-Du#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} or #{@cX.ruby}-D#{@cX.off} #{@cX.ruby}update#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off} updates/imports specified data  to  postgresql  db (rb.dbi) [#{@cX.ruby}-P update#{@cX.off} using rb.psql; #{@cX.ruby}-d update#{@cX.off} sqlite equivalent]

 #{@cX.ruby}-D#{@cX.off} #{@cX.ruby}remove#{@cX.off} #{@cX.green}[filename/wildcard]#{@cX.off}  removes  specified  data  to postgresql db (rb.dbi) [#{@cX.ruby}-P remove#{@cX.off} using rb.psql; #{@cX.ruby}-d remove#{@cX.off} sqlite equivalent]

 #{@cX.ruby}-D#{@cX.off} #{@cX.ruby}dropall#{@cX.off} kills data" and drops (postgresql or sqlite) db, tables & indexes

  also see command  #{@cX.green}shortcuts#{@cX.off}, and shorthand mappings for multiple flags
WOK
    end
    def shortcuts
      print <<WOK

 #{@cX.ruby}Shorthand for multiple flags#{@cX.off}
 
        #{@cX.ruby}--update#{@cX.off}  #{@cX.green}[filename/wildcard]#{@cX.off} Checks  existing file output and runs the flags required to update this output. This means that if only html and pdf output  was  requested  on previous  runs, only the -hp files will be applied, and only these will be generated this time, together with the summary.  This  can  be  very convenient, if you offer different outputs of different files, and just want to do the same again.

       #{@cX.ruby}-1#{@cX.off} to #{@cX.ruby}-5#{@cX.off} #{@cX.green}[filename or wildcard]#{@cX.off}
       #{@cX.green}Default shorthand mappings#{@cX.off} (note that the defaults can be changed in the #{@cX.green}sisurc.yaml#{@cX.off} file):

       #{@cX.ruby}-1#{@cX.off} == -mNHwpy
       #{@cX.ruby}-2#{@cX.off} == -mNHwpaoy
       #{@cX.ruby}-3#{@cX.off} == -mNHwpaobxXy
       #{@cX.ruby}-4#{@cX.off} == -mNHwpaobxXDiy
       #{@cX.ruby}-5#{@cX.off} == -mNHwpaobxXDuy

       add -v for verbose mode and -c (color toggle), e.g.
       sisu -2vc [filename  or  wildcard]
WOK
    end
    def misccom
      <<WOK
  #{@cX.cyan}misc#{@cX.off}
  #{@cX.green}-s#{@cX.off} [filename or wildcard]          #{@cX.green}spellcheck#{@cX.off} (aspell previously ispell
  \t#{@cX.green}mailer examples#{@cX.off}
  from vim mail.er10 (not gvim) issue command 
  \t:! ruby -S mailer.rb instruction/landscape|a4l|portrait|a4p/ email@address/alias subject line
  \t:! ruby -S mailer.rb a4l ralph@amissah.com testing continues
  from vim mail.er10 use your vim alias \\mail or \\mutt (modify command line as required)
  #{@cX.green}feeds rss/rdf#{@cX.off} 
  #{@cX.blue}-R #{@cX.off} (yaml|rss)  extraction of semantic data into yaml file for auto build of xml feeds (rss, rdf) #{@cX.fuschia}[work area]#{@cX.off}
  #{@cX.green}-R #{@cX.off} yaml  extraction of semantic data into yaml file for auto build of xml feeds (rss, rdf)
  #{@cX.green}-R #{@cX.off} rss   creates rss2.0 feed
WOK
    end
    def markup
      print <<WOK
sisu
  Note: files for SiSU should be in UTF-8 character encoding.

  #{@cX.cyan}Data text markup#{@cX.off} (alternative to available html subset)
  #{@cX.green}1~#{@cX.off} heading/title                                                [levels 1 to 6 available]
  #{@cX.green}4~#{@cX.off}filename heading                       [segmentation level]
  #{@cX.green}!{#{@cX.off}emphasis#{@cX.green}}!#{@cX.off}
  #{@cX.green}*{#{@cX.off}bold text#{@cX.green}}*#{@cX.off}
  #{@cX.green}_{#{@cX.off}underscore#{@cX.green}}_#{@cX.off}
  #{@cX.green}/{#{@cX.off}italics#{@cX.green}}/#{@cX.off}
  #{@cX.green}"{#{@cX.off}citation#{@cX.green}}"#{@cX.off}
  #{@cX.green}^{#{@cX.off}superscript#{@cX.green}}^#{@cX.off}
  #{@cX.green},{#{@cX.off}subscript#{@cX.green}},#{@cX.off}
  #{@cX.green}+{#{@cX.off}inserted text#{@cX.green}}+#{@cX.off}
  #{@cX.green}-{#{@cX.off}strikethrough#{@cX.green}}-#{@cX.off}
  ------------------------------------------
  #{@cX.cyan}Indentation and bullets#{@cX.off}
  #{@cX.green}_1#{@cX.off}                     indent paragraph one level
  #{@cX.green}_2#{@cX.off}                     indent paragraph two steps
  #{@cX.green}_*#{@cX.off}                     bullet text
  #{@cX.green}_1*#{@cX.off}                    bullet text, first indent
  ------------------------------------------
  #{@cX.cyan}Numbered List#{@cX.off} (not to be confused with headings/titles, (document structure))
  #{@cX.green}##{@cX.off} numbered list        numbered list 1., 2., 3, etc.
  #{@cX.green}_##{@cX.off} numbered list       numbered list indented second level a., b., c., d., etc.
  ------------------------------------------
  #{@cX.cyan}Endnotes#{@cX.off}
  #{@cX.green}~{#{@cX.off}endnote#{@cX.green}}~#{@cX.off}    endnote#{@cX.green}~{#{@cX.off}self contained endnote marker & endnote in one#{@cX.green}}~#{@cX.off}
  ---
  alternative endnote pair notation
  #{@cX.green}~^#{@cX.off}                                           endnote marker
  #{@cX.green}^~#{@cX.off} endnote text following the paragraph in which the marker occurs
  ------------------------------------------
  #{@cX.cyan}Links#{@cX.off}
    http://url.org                           on its own would be automatically marked up and hyperlinked to itself
    #{@cX.green}{#{@cX.off} [text to link] #{@cX.green}}#{@cX.off}http://url.org
    #{@cX.green}{#{@cX.off}image.png#{@cX.green}}#{@cX.off}http://url.org
    #{@cX.green}{#{@cX.off}image.png#{@cX.green}}#{@cX.off}image    #{@cX.green}{#{@cX.off}tux.png 64#{@cX.green}x#{@cX.off}80#{@cX.green}}#{@cX.off}image
  Linked image example
    #{@cX.green}{#{@cX.off} SiSU Geek Writer #{@cX.green}}#{@cX.off}http://www.jus.uio.no/sisu/                   url example
    #{@cX.green}{#{@cX.off}tux.png 64#{@cX.green}x#{@cX.off}80 "a better way" #{@cX.green}}#{@cX.off}http://www.jus.uio.no/sisu/    image example with all options (width x height)
    Note: png and jpg support only (no gif support)
 
  shortcut - hyper-linked text with endnote providing the url information
    #{@cX.green}{~^#{@cX.off} [text to link] #{@cX.green}}#{@cX.off}http://url.org         maps to   #{@cX.green}{#{@cX.off} [text to link] #{@cX.green}}#{@cX.off}http://url.org #{@cX.green}~{#{@cX.off} http://url.org #{@cX.green}}~#{@cX.off}
     produces hyper-linked text within a document/paragraph, with an endnote providing the url for the text location used in the hyperlink
  ------------------------------------------
  adding fixed names in html, manual location marker/tagging
  #{@cX.green}*~[name]#{@cX.off}           <a name="[name]">
  ------------------------------------------
  #{@cX.green}~##{@cX.off}         unnumbered paragraph (place marker at end of paragraph)
  #{@cX.green}-##{@cX.off}         unnumbered paragraph, delete when not required (place marker at end of paragraph) [used in dummy headings, eg. for segmented html]
  ------------------------------------------
  manual page breaks (LaTeX/pdf)
  #{@cX.green}<:pb>#{@cX.off}  page  break,  which  breaks a page, starting a new page in single column text and a new column in double column text
  #{@cX.green}<:pn>#{@cX.off} page new, which starts a new page, in both single and double column text (leaving an empty column in double column text if necessary).
  Note: page breaks are usually introduced to pdfs either as header instructions, indicating that pages should break at given levels
  ------------------------------------------
  #{@cX.cyan}Composite documents#{@cX.off}
    It is possible to build a document by requiring other documents. The documents required may complete documents that could be generated independently, or they could be markup snippets, prepared so as to be easily available to be placed within another text. If the calling document is a master document (built mainly from other documents), by convention it should be named with the suffix .ssc or .ssm The documents called if complete documents would have the suffix .sst, [.ssf, or .ssd], and if markup snippets .ssi. A temporary file of the composite document is built prior to processing with the same prefix and the suffix ._sst There are a number of alternative syntaxes for requiring external documents in order to permit use of ascii hypertext linking available in the vim editor. They are as follows (place at start of line):  
 
    #{@cX.cyan}#basic sisu markup alternatives#{@cX.off}
      #{@cX.green}{#{@cX.off}filename.si#{@cX.green}}require#{@cX.off}
      #{@cX.green}<< {#{@cX.off}filename.si#{@cX.green}}#{@cX.off}

    #{@cX.cyan}#using textlink alternatives#{@cX.off}
      #{@cX.green}|#{@cX.off}filename.si#{@cX.green}|@|^|require#{@cX.off}
      #{@cX.green}<< |#{@cX.off}filename.si#{@cX.green}|@|^|#{@cX.off}

    #{@cX.cyan}#using thlnk alternatives#{@cX.off}
      #{@cX.green}<url:#{@cX.off}filename.si#{@cX.green}>require#{@cX.off}
      #{@cX.green}<< <url:#{@cX.off}filename.si#{@cX.green}>#{@cX.off}

  #{@cX.cyan}Composite documents - remote parts#{@cX.off}
    Composite documents may be built from remote parts, by using the composite document syntax with a url. This makes sense using either sisu regular syntax (which is just a convenient way of marking up), or thlnk syntax, which also recognises remote urls, and permits hyperlinking ascii to the url location.

  #{@cX.cyan}Remote documents#{@cX.off}
    SiSU will download and process remote locations if a url is provided instead of a filename. [this at present works only for sisu markup files without images]

  ------------------------------------------
  #{@cX.green}%#{@cX.off}#{@cX.off}       add a comment to text, that will be removed prior to processing (place marker at beginning of line)
  #{@cX.green}\\#{@cX.off}#{@cX.off}       escape a sepcial character, whether general: { } < > or contextual special characters, (in combination with  other  characters) ~  - _ / % ^ and occasionally ! # + , 
  #{@cX.green}%%#{@cX.off}#{@cX.off}      same as above but recognised by vim folds for placing fold in document text, in addition to headers and headings
  ------------------------------------------
  
  #{@cX.ruby}More HELP on Markup#{@cX.off} markup help is available on:
    document wide instructions: headers (document structure)
    general text markup: headings; endnotes; tables (which also includes a note on preformatted text)
  configuration and customisation
    document or site wide customisation: customise; skin


WOK
#  {../_sisu/image/tux.png http://www.jus.uio.no/sisu/ w=64 c=\"a better way\" }:image        depreciated image eg
#  <!image http://www.jus.uio.no/sisu/ ../_sisu/image/tux.png  width=\"64\" height=\"80\" !>   old form
    end
    def markupOld # kept as is easier to read!
      print <<WOK
sisu
  #{@cX.green}script markup (alternative to available html subset)#{@cX.off}
  1~ heading
  4~filename heading
  !{emphasis}!        e{emphasis}e       <strong>emphasis</strong>
  *{bold text}*       b{bold}b           <b>bold text</b>
  _{underline}_       u{underline}u      <u>underline</u>
  /{italics}/         i{italics}i        <i>italics</i>
  "{citation}"        c{citation}c       <cite>citation</cite>
  ^{superscript}^     9{superscript}9    <sup>superscript</sup>
  ,{subscript},       6{subscript}6      <sub>subscript</sub>
  +{inserted text}+   v{inserted}v       <ins>inserted text</ins>
  -{strikethrough}-   x{deleted}x        <del>deleted text</del>

  ~{endnote}~                          endnote~{self contained endnote marker & endnote in one}~
  ~^                                     endnote marker
  ^~                                    endnote text following the paragraph in which the marker occurs
  
  _1                                     indent paragraph one level
  _2                                     indent paragraph two steps
  
  {link name}http://url.org
  {image.png}http://url.org
  {image.png}image    {tux.png w=64 h=80}image
  
  {SiSU Geek Writer}http://www.jus.uio.no/sisu/                         url example
  {tux.png w=64 h=80 \"a better way\" }http://www.jus.uio.no/sisu/      image example with all options
  
    markup help is available on:
    document wide instructions: headers
    general text markup: headings; endnotes; tables
  configuration
    site wide customisation: customise
    available modules: modules
    setup: setup
  
  {../_sisu/image/tux.png http://www.jus.uio.no/sisu/ w=64 c=\"a better way\" }:image        depreciated image eg
    
  Note: png and jpg support only (no gif support)

WOK
    end
    def example
      print <<WOK

0~title Working Sample Document

0~subtitle Demonstrating markup

0~creator Ralph Amissah

0~date 

0~markup num_top=4 

0~bold [regular expression of words/phrases to be made bold]

0~italics [regular expression of words/phrases to italicise]

0~links { SiSU }http://www.jus.uio.no/sisu { FSF }http://www.fsf.org

1~ A Sample Document
  
2~ just for fun 
    
4~ This is Chapter One or Article One

Ordinary Text follows here. The Title would be a Chapter or Article depending on the type of document you were working to produce.

4~ This would be Chapter Two or Article Two

And so on.

Assuming sisu is configured properly so it has been instructed where to put the work files and ouput files, you would generate this text once saved, with the suffix .sst if saved as example.sst, by typing sisu -mhwxp example.sst while in the directory in which the file is saved. 

_1 -m initial processing, -h html (css based), -w wordmap for html, -x xml, -p pdf output, generated via latex, there are of course additional options

_1 for a listing type: sisu ~ commands

_1 for an outline of sisu markup type: sisu ~ markup 

The example ends here.

WOK
  end
  def headers
    print <<WOK
Header tags appear at the beginning of a document and provide meta information on the document (such as the Dublin Core), or information as to how the document as a whole is to be processed.
All header instructions take either the form #{@cX.green}0~#{@cX.off}. All Dublin Core meta tags are available
#{@cX.green}0~indentifier#{@cX.off} information or instructions
where the #{@cX.green}"identifier"#{@cX.off} is a tag recognised by the program, and the #{@cX.green}"information"#{@cX.off} or #{@cX.green}"instructions"#{@cX.off} belong to the tag/indentifier specified
 Note: a header where used should only be used once;  all  headers  apart from 0~title are optional; the 0~toc header is used to describe document structure, and can be useful to know.
This is a sample header (#{@cX.fuschia}Dublin Core in fuschia,#{@cX.off} #{@cX.cyan}other information headers in cyan,#{@cX.off} #{@cX.ruby}markup instructions in red#{@cX.off}):

#{@cX.green}0~#{@cX.off}#{@cX.fuschia}title#{@cX.off} My Title - This is now the Title of the Document and used as such

#{@cX.green}0~#{@cX.off}#{@cX.cyan}subtitle#{@cX.off} The Subtitle if any

#{@cX.green}0~#{@cX.off}#{@cX.fuschia}creator#{@cX.off} [or ~author] Ralph Amissah

#{@cX.green}0~#{@cX.off}#{@cX.fuschia}subject#{@cX.off} (whatever your subject)

#{@cX.green}0~#{@cX.off}#{@cX.fuschia}description#{@cX.off} 

#{@cX.green}0~#{@cX.off}#{@cX.fuschia}publisher#{@cX.off} 

#{@cX.green}0~#{@cX.off}#{@cX.fuschia}contributor#{@cX.off} 

#{@cX.green}0~#{@cX.off}#{@cX.fuschia}translator#{@cX.off} [or ~translated_by]

#{@cX.green}0~#{@cX.off}#{@cX.fuschia}illustrator#{@cX.off} [or ~illustrated_by]

#{@cX.green}0~#{@cX.off}#{@cX.fuschia}prepared_by#{@cX.off} [or ~digitized_by]

#{@cX.green}0~#{@cX.off}#{@cX.fuschia}date#{@cX.off} 2000-08-27
\t[ also #{@cX.green}0~#{@cX.off}#{@cX.fuschia}date.created#{@cX.off} #{@cX.green}0~#{@cX.off}#{@cX.fuschia}date.issued#{@cX.off} #{@cX.green}0~#{@cX.off}#{@cX.fuschia}date.available#{@cX.off} #{@cX.green}0~#{@cX.off}#{@cX.fuschia}date.valid#{@cX.off} #{@cX.green}0~#{@cX.off}#{@cX.fuschia}date.modified#{@cX.off} ]

#{@cX.green}0~#{@cX.off}#{@cX.fuschia}type#{@cX.off} article

#{@cX.green}0~#{@cX.off}#{@cX.fuschia}format#{@cX.off}

#{@cX.green}0~#{@cX.off}#{@cX.fuschia}identifier#{@cX.off}

#{@cX.green}0~#{@cX.off}#{@cX.fuschia}source#{@cX.off}

#{@cX.green}0~#{@cX.off}#{@cX.fuschia}language#{@cX.off} [country  code  for  language  if  available,  or  language, English, en is the default setting] (en - English, us - US English, fr - French,  de  - German, it - Italian, es - Spanish, pt - Portuguese, br - Brazilian Portuguese, se - Swedish, dk - Danish, fi - Finnish, no - Nor wegian,  is - Icelandic, nl - Dutch, ee - Estonian, hu - Hungarian, pl - Polish, ro - Romanian, ru - Russian, gr - Greek, ua  -  Ukranian,  tr  - Turkish, si - Slovene, sk - Slovak, hr - Croatian, cz - Czech, bg - Bul garian ) [however, encodings are not available for all of the  languages listed.]

#{@cX.green}0~#{@cX.off}#{@cX.fuschia}relation#{@cX.off}

#{@cX.green}0~#{@cX.off}#{@cX.fuschia}coverage#{@cX.off}

#{@cX.green}0~#{@cX.off}#{@cX.fuschia}rights#{@cX.off} copyright, all rights reserved, public domain, copyleft, creative commons variant, etc.

#{@cX.green}0~#{@cX.off}#{@cX.cyan}owner#{@cX.off}

#{@cX.green}0~#{@cX.off}#{@cX.cyan}keywords#{@cX.off} text document generation processing management latex pdf structured xml citation [your keywords here, used for example by rss feeds, and in sql searches]

#{@cX.green}0~#{@cX.off}#{@cX.cyan}abstract#{@cX.off} [paper abstract, placed after table of contents]

#{@cX.green}0~#{@cX.off}#{@cX.cyan}comment#{@cX.off} [...]

#{@cX.green}0~#{@cX.off}#{@cX.cyan}classify_loc#{@cX.off} Library of Congress classification

#{@cX.green}0~#{@cX.off}#{@cX.cyan}classify_dewey#{@cX.off} Dewey classification system

#{@cX.green}0~#{@cX.off}#{@cX.cyan}classify_isbn#{@cX.off} ISBN

#{@cX.green}0~#{@cX.off}#{@cX.cyan}classify_pg#{@cX.off} Project Gutenberg text number

#{@cX.green}0~#{@cX.off}#{@cX.cyan}prefix_a#{@cX.off} [prefix is placed just before table of contents - not implemented]

#{@cX.green}0~#{@cX.off}#{@cX.cyan}prefix_b#{@cX.off} or #{@cX.green}0~#{@cX.off}#{@cX.cyan}prefix#{@cX.off} [prefix is placed just after table of contents]

#{@cX.green}0~#{@cX.off}#{@cX.cyan}rcs#{@cX.off} $Id$ [used by rcs or cvs to embed version (revision control) information into document, rcs or cvs can usefully provide a history of updates to a document ]

#{@cX.green}0~#{@cX.off}#{@cX.ruby}toc#{@cX.off} PART; CHAPTER; SECTION; ARTICLE; none; none;
optional, where document structure can be defined by a match words or regular expression (the regular expression is assumed to start at the beginning of a line of text i.e. ^)
default markers 1~ to 6~ can be used within text instead, without this header tag, and may be used to suppliment the instructions provided in this header tag if provided

#{@cX.green}0~#{@cX.off}#{@cX.ruby}level#{@cX.off} newpage=3; breakpage=4 [paragraph level, used by latex to breakpages, the page is optional eg. in newpage] 

#{@cX.green}0~#{@cX.off}#{@cX.ruby}markup#{@cX.off} num_top=4 [various markup instructions, eg: num_top=4 headings tobe numbered, starting at heading level 4... the default is to provide 3 levels, as in 1 level 4, 1.1 level 5, 1.1.1 level 6, markup to be merged within level]

#{@cX.green}0~#{@cX.off}#{@cX.ruby}bold#{@cX.off} [list of words to make bold with semi colon separator] 

#{@cX.green}0~#{@cX.off}#{@cX.ruby}italics#{@cX.off} [list of words to italize with semi colon separator] 

#{@cX.green}0~#{@cX.off}#{@cX.ruby}vocabulary#{@cX.off} name of taxonomy/vocabulary/wordlist to use against document

#{@cX.green}0~#{@cX.off}#{@cX.ruby}skin#{@cX.off} skin_doc_[name_of_desired_document_skin]

#{@cX.green}0~#{@cX.off}#{@cX.ruby}links#{@cX.off} http://google.com; Google;

#{@cX.grey}% header ends here, [this would be a comment]#{@cX.off}

#{@cX.blue}1~#{@cX.off} Top level heading [this is usually the same as the title 0~title ]

#{@cX.blue}2~#{@cX.off} Second level heading [this is a heading level divider]

#{@cX.blue}3~#{@cX.off} Third level heading [this is a heading level divider]

#{@cX.blue}4~#{@cX.off} Top level heading preceding substantive text of document or sub-heading 5, the heading level that would normally be marked 1. or 2. or 3. etc. in a document

#{@cX.blue}5~#{@cX.off} Second level heading preceding substantive text of document or sub-heading 6, the heading level that would normally be marked 1.1 or 1.2 or 1.3 or 2.1 etc in a document

#{@cX.blue}6~#{@cX.off} Third level heading preceding substantive text of document, that would normally be marked 1.1.1 or 1.1.2 or 1.2.1 or  2.1.1 etc. in a document

WOK
    end
    def customise
      print <<WOK
    There are a number of files that control the appearance of a site or a document i.e.

    #{@cX.blue}(i)#{@cX.off} files that control #{@cX.green}site-wide appearance#{@cX.off}:

        #{@cX.green}defaults.rb#{@cX.off}  initial values used by program, not necessary to change

        skins are placed in a configuration directory beneath the markup directory ./_sisu/skin/doc or in ~/.sisu/skin/doc
        if a skin is also to be used for a directory or site wide presentations, rather than being called for a single document then a softlink is placed from ~/.sisu/skin/dir or ~/.sisu/skin/site respectively to the relevant skin within ~/.sisu/skin/doc
        
        rules for skin loading are in #{@cX.green}sysenv.rb#{@cX.off}
        the skin loading heuristics / hierarchy is currently as follows:

          a. if there is a skin requested within a document, thent that skin is used 
            0~skin skin_lm (would load skin ~/.sisu/#{Version}/skin/doc/skin_lm.rb)

          b. use it if there is a "dir" skin with the same name as the source directory "stub" i.e.
            if working in a directory called /home/myhome/workdir/lm
            then if ~/.sisu/#{Version}/skin/dir/skin_lm.rb were found it would be used and skin_lm.rb would be a softlink to the relevant skin in the document skin directory (where all the actual skins are kept)

          x. [additionally though discouraged a special rule can be set up in sysenv  AddSkin.select (which could override b if desired)]

        #{@cX.green}skin_site_#{@cX.off}#{@cX.cyan}[name of site skin in use]#{@cX.off}#{@cX.green}.rb#{@cX.off}  this file is called by skin.rb
          if there are several such files, site appearance may be changed by 
          requesting the skin_site desired from skin.rb
    and 

    #{@cX.blue}(ii)#{@cX.off} presentation maintenance:
          if you have a body of documents the easiest way to give them a particular appearance/skin, is to associate that directory with a skin, all files in that directory take on the specified appearance, changing appearance of documents once directories are set up is as simple as copying the files from one directory to another (or renaming the directory); or associating the directory with a different skin.

    see also directories
WOK
    end
    def configure
      print <<WOK
      see the following topics
        install
        setup
        and note for initial configuration it is necessary to run:
          sisu -C
          (this places the default CSS files and DTDs in place)

WOK
    end
    def path
      puts <<WOK

If you have problems check permissions (and if in home directory ownership).

#{@cX.green}directory paths as currently set#{@cX.off}:      
  output docs:                 #{@cX.blue}#{@dir.webserv_path}#{@cX.off}
  cgi scripts:                 #{@cX.blue}#{@dir.cgi}#{@cX.off}
  processing:                  #{@cX.blue}#{@dir.processing}#{@cX.off}
      sisu meta markup:        #{@cX.blue}#{@dir.metaverse}#{@cX.off}
      html tuning:             #{@cX.blue}#{@dir.tune}#{@cX.off}
      latex:                   #{@cX.blue}#{@dir.tex}#{@cX.off}
      texinfo:                 #{@cX.blue}#{@dir.texi}#{@cX.off}
  images:
    source:                    #{@cX.blue}#{@dir.image_source}#{@cX.off}
    latex source:              #{@cX.blue}#{@dir.image_source_tex}#{@cX.off}
    note images are also sourced from within your pwd - #{@cX.blue}#{Dir.pwd}/_sisu/sisu/image_local#{@cX.off} if it exists
  #{@cX.grey}[ texinfo:                     #{@dir.texinfo} - check duplication ]#{@cX.off}

 #{@cX.green}resource configuraton files#{@cX.off} to change the paths specified above, are searched for in the following order:
   under the current SiSU markup data directory: #{@cX.blue}#{Dir.pwd}/_sisu/sisurc.yaml#{@cX.off}
   under the home directory ~/.sisu:             #{@cX.blue}#{@dir.home}/.sisu/sisurc.yaml#{@cX.off}
   in the "/etc" directory:                      #{@cX.blue}#{@dir.etc}/sisurc.yaml#{@cX.off}
   default file paths are set by the program SiSU
  
 #{@cX.green}skins#{@cX.off} for document appearances on a site, directory or per document basis are located in subdirectories #{@cX.blue}doc/#{@cX.off}  #{@cX.blue}dir/#{@cX.off} and #{@cX.blue}site/#{@cX.off} within:
   #{@cX.blue}#{Dir.pwd}/_sisu/skin#{@cX.off}
   #{@cX.blue}#{@dir.home}/.sisu/skin#{@cX.off}
   #{@cX.blue}#{@dir.etc}/skin#{@cX.off}
   default appearances are set by the program SiSU in the absence of skins

   #{@cX.green}Note on subdirectories for output documents#{@cX.off}
   The last part of the name of the directory you choose to work from is used as the major sub-directory in which output files are placed,
   i.e. if you are working in a directory called #{@cX.blue}#{@dir.home}/ebook#{@cX.off}
        the output files will be placed in a sub-directory named after the processed text within #{@cX.blue}#{@dir.webserv_path}/ebook#{@cX.off}
   ( Within this major sub-directory, a sub-directory is made with the name of each document processed, into which output files - html, pdf, xml, plaintext etc. are placed (texinfo being an exception at present) )

    #{@cX.green}sisu -C#{@cX.off} or #{@cX.green}sisu -CC#{@cX.off} in a new markup document working directory should initialise the corresponding output directory, though SiSU will automatically do this, the first time it is run (for processing) in a given directory.

   There are additional details, ... this should get you started.

   See also
      sisu help directory
  
WOK
    end
    def directories
      print <<WOK

  the directory structure used by sisu is controlled by the configuration files #{@cX.blue}sisurc.yaml#{@cX.off}

   there are separate directories for the following:

    (a) #{@cX.green}data directories#{@cX.off}
      the directories in which you place the SiSU marked-up data files that are to be processed
      there may be as many directories and files as you choose to have, 
      you are currently in:                                    #{@cX.blue}#{Dir.pwd}#{@cX.off}

    (b) #{@cX.green}output directory#{@cX.off}     
      by default files in the data directory are output to 
      a sub-directory within the output directory (usually the web document directory), or to an sql database
      of the same name as the stub or last portion of the data directory name
      by way of example 
      you are currently in:                                    #{@cX.blue}#{Dir.pwd}#{@cX.off}
      the document output directory is set to:                 #{@cX.blue}#{@dir.webserv_path}#{@cX.off}
      documents from your current directory will be placed in: #{@cX.blue}#{@dir.data_o}#{@cX.off}
    
      the final output is placed in subdirectories either as configured by default in the program or as modified by SiSU configuration files
      subdirectories are created within the main output directory, based on the name of the data directory
      subsubdirectories are created the sub-directory contained in the main output directory based on the name of the file
      (subdirectories are created in this (output) sub-directory named after the data file)
      for this reason it is a convention to give descriptive names to the data file.
      The default output directory is #{@cX.green}~/sisu_www#{@cX.off}
      The output directory is currently set to:
        #{@cX.blue}#{@dir.webserv_path}#{@cX.off}
      Output files, are currently set to be produced in:
        processed document output:           #{@cX.blue}#{@dir.data_o}#{@cX.off}
        a document in the current directory  #{@cX.blue}#{Dir.pwd}#{@cX.off}
            will have its output placed in:  #{@cX.blue}#{@dir.data_o}/#@output_stub#{@cX.off}

      NB: the verbose flag v included in the generate command string, should 
      result in a list of output filenames together with their paths.
      The flag U on its own (e.g. sisu -U gpl2.fsf.sst) should provide a list 
      of output files that could be generated together with their paths. 

    (c) #{@cX.green}configuration files#{@cX.off}
       SiSU program defaults are set within the program, and may be adjusted in the yaml file #{@cX.blue}sisurc.yaml#{@cX.off} which is searched for in the following paths, which are prioritized as listed (the first one found is loaded):
       under the current SiSU markup data directory: #{@cX.blue}#{Dir.pwd}/_sisu/sisurc.yaml#{@cX.off}
       under the home directory ~/.sisu:             #{@cX.blue}#{@dir.home}/.sisu/sisurc.yaml#{@cX.off}
       in the "/etc" directory:                      #{@cX.blue}#{@dir.etc}/sisurc.yaml#{@cX.off}

    (d) #{@cX.green}processing directories#{@cX.off}     sisu creates a number of processing directories, 
      where these should be located can be modified in #{@cX.green}~/.sisu/sisurc.yaml#{@cX.off}
      work directories include the following:
          root working directory                               #{@cX.blue}#{@dir.processing}#{@cX.off}
          metaverse       intermediate markup                  #{@cX.blue}#{@dir.metaverse}#{@cX.off}
          tune html       (for special html/navigation pages)  #{@cX.blue}#{@dir.tune}#{@cX.off}
          tex             for latex and pdf                    #{@cX.blue}#{@dir.tex}#{@cX.off}
          texinfo         for texinfo and info files           #{@cX.blue}#{@dir.texi}#{@cX.off}

      These files are usually used only for processing and removed. There is a maintenance flag to keep them.

    (e) #{@cX.green}images#{@cX.off}
      there are a number of categories of images, 
      NB the document markup directory is initialised by issuing the command sisu -CC
      this creates the output sub-directory, and makes necessary image links, and 
      copies images specific to the markup directory if there are any.
      
      general images for the sisu program that come with the package, 
      that are the defaults used by sisu, these are installed with the program

      images that the author wishes to include within documents, 
      these should be placed in a sub-directory 
      within the current document markup directory called #{@cX.green}_sisu/sisu/image_local#{@cX.off}

      if an instruction is given to process a remote document which contains
      downloadable images, they are included in a sub-directory of the current
      markup directory #{@cX.green}_sisu/sisu/image_external#{@cX.off} that is created
      if necessary for the purpose.
    
      finally skins may specify/indicate other image directories. see sisu help skin
      any site images required by the skin instruction must be copied in to the 
      site image directory (it may be necessary to do manual configuration depending
      on what you are trying to achieve).

    (f) #{@cX.green}program directories#{@cX.off}
      sisu help install
      sisu ~ install

 See also
    sisu help path
WOK
  end
  def dublinCore
    print <<WOK
0~title

0~subtitle [is added to title for purposes of Dublin Core description] 

0~creator 

0~type 

0~subject 

0~date [ccyy-mm-dd]

0~date.created 

0~date.issued 

0~date.available 

0~date.valid 

0~date.modified 

0~source

0~language en

0~papersize A4

0~relation

0~coverage

0~rights

WOK
    end
    def headings
      print <<WOK
These are not always required, (eg. if document structure can be defined by matching words or a regular expression, this can instead be set in the header, see headers) but the following defaults are always available:

1~  2~  3~  4~  5~  6~
Heading tags take either of the forms above, ranging from 1-6

They appear at the beginning of the line on which a heading appears,
the number indicates the level of the heading with level 1 being a title,

segments (in html output) are by default created on level 4 
(segmented text is split/segmented on level 4, and 
assigned a file name automatically according to the title number, 
unless you explicitly specify otherwise)

eg.

1~ Title

2~ Subtitle whatever it is

3~ Part

4~ Chapter

5~ Heading

6~ sub-heading 

or

1~ Part

2~ Chapter

3~ Section

4~ Heading

Normal text would follow each heading level as appropriate, 
though it is most usual to start with ordinary writing beneath level 4 
as it is at this level that segments are created.

Automatic numbering of paragraphs is usually set to start at level 4 trough level 6
and takes the form 1. then 1.1 then 1.1.1 this being given as a Header tag 0~
There may be up to 6 levels in a document, 

If auto-numbering is on, then for html output the segments created  (on level 4 headings) 
are automatically assigned the name of the title number. 
However, you may indicate an alternative set of key/title words, with one of the following instructions:
4~filename This is a Section or Subject Heading

If there is a strictly discernable word appearing at the beginning of the line in a document that identifies the level, 
the words can be used to identify the levels in a header tag: 
0~toc Part; Chapter; Section; Article; none; none
instead of providing individual heading tags

WOK
    end
    def languages
    puts <<WOK

    Multi-language Document File Naming and Directory Mapping
    
    If the same document exists in different language versions, and it is desired that the published language versions should reside in the same output directory, the following filenaming convention should be observed, using Spannish as the sample language code (es) [it is very likley the use of country codes as language codes will be changed or extended in future] [filename]~[language code].sst

  filename~es.sst

  within sisurc.yaml under the heading 
    default:
      language file: [at 1, 2 or 3]
      
  determines the output filenaming convention used, as follows:

    (1) [output directory path]/filename/es.index.html

    (2) [output directory path]/filename/index.es.html

    (3) [output directory path]/filename/index.html.es (which Apache for example can be configured to use to automatically serve each users preference)

    filename~fr.sst
    filename~de.sst

  etc. would be placed in the same directory using the same convention as indeed would:
    filename.sst
  using the default convention mapping convention.

  Selecting this form of filename will overide other language settings including the language header within a document.

WOK
    end
    def endnotes
      print <<WOK

(1) Footnote/endnotes tags take a number of possible forms, the simplest being to embed an endnote within your text~{ this would appear as an endnote, and would have an automatically assigned number }~ Embedded endnotes~{this is an endnote}~ and at the end of the paragraph writing the endnote:~{another endnote}~

  ------------------------------------------
#{@cX.ruby}All you need to know about endnotes appears above this line...#{@cX.off} apart from the fact that you cannot mix endnote markup styles

(2) The other ways of inserting an endnote involve placing a tag within the text as to where the endnote reference number should appear like so~^ and at the end of the paragraph writing the endnote:~^

^~ like so, this is an endnote

^~ another endnote

WOK
    end
    def tables
      print <<WOK

#{@cX.green}table{ [number of columns] [column width %];[column width %]#{@cX.off}

[table content, line breaks are important see example below]

#{@cX.green}}table#{@cX.off}
#{@cX.grey}----#{@cX.off}
This is a sample table:
-----------------------

#{@cX.green}table{ c3; 40; 30; 30;#{@cX.off}

This is a table
this would become column two of row one
column three of row one is here

And here begins another row
column two of row two
column three of row two, and so on

#{@cX.green}}table#{@cX.off}

preformatted text
-----------------

#{@cX.green}poem{#{@cX.off}

  [Text here]

#{@cX.green}}poem#{@cX.off}
#{@cX.grey}----#{@cX.off}

#{@cX.green}group{#{@cX.off}

  [Text here]

#{@cX.green}}group#{@cX.off}
#{@cX.grey}----#{@cX.off}

#{@cX.green}code{#{@cX.off}

  [Text here]

#{@cX.green}}code#{@cX.off}

WOK
    end
    def modules
      print <<WOK

      #{@cX.ruby}DATED NOT CURRENT - IGNORE#{@cX.off}
    
    This file is to contain some information the different programs that form sisu:

      their inter-relationship (for which see sisu-chart.pdf)
    
    and

      what they do

      sisu\ttui/command line program that when run with flags against files produces requested output

      ~/.sisu/#{Version}\tconfiguration directory, contains sisu configuration, and skins for alternative appearances
      param\tgathers parameters from the sourcefile, when called by metaverse parameters are saved to pstore file
      sysenv\tgets system information, and builds directory structure
      
      init\tintialised defaults for appearance
      skin\tsite wide skin
      format\tformatting instructions assosciated with and used by calling module
      
      metaverse\tinitial processing stage, preliminary file on which subsequent processing is done is created [-m]
      
      plaintext\tplaintext creating module [-a]
      html\thtml creating modules [-h]
      texpdf\tlatex and pdf creating modules [-p]
      xml & xml_dom\txml creating modules [-x -X]
      wmap\tword map creating module [-w]

      termsheet\tcreation of documents from termsheet and standard forms [-t]

      dbi\tdbi database build and populating module, default postgresql [-D]
      dbi_sqlite\tdbi database build and populating module, for sqlite [-d]

      #{@cX.ruby}DATED NOT CURRENT - IGNORE#{@cX.off}

WOK
    end
    def sql
      print <<WOK

  Postgresql
    user:             #{@db.user}
    current db set:   #{@db.db_psql}
    port:             #{@db.port_psql}
    dbi connect:      #{@db.dbi_psql}

  #{@cX.grey}sqlite
    current db set:   #{@db.db_sqlite}
    dbi connect       #{@db.dbi_sqlite} #{@cX.off}

   #{@cX.green}Note on databases built#{@cX.off}
   By default, [unless otherwise specified] databases are built on a directory basis, from collections of documents within that directory.
   The name of the directory you choose to work from is used as the database name,
   i.e. if you are working in a directory called #{@cX.blue}#{@dir.home}/ebook#{@cX.off} the database #{@cX.blue}ebook#{@cX.off} is used.
       #{@cX.grey}[otherwise a mapping for the collection is necessary]#{@cX.off}

WOK
    end
    def install
                                                                 #% system configuration
      print <<WOK
  #{@cX.green}Install SiSU#{@cX.off}
  
  SiSU does require setup, the file sisu is placed in the equivalent of #{@cX.blue}/usr/bin#{@cX.off} or #{@cX.blue}/usr/local/bin#{@cX.off} and the REWRITE files where ruby libraries are kept, on my debian system #{@cX.blue}/usr/local/lib/site_ruby/1.8#{@cX.off}

  For information on download and installation, see #{@cX.blue}http://www.jus.uio.no/sisu/sisu_download/download#{@cX.off} or #{@cX.blue}http://www.jus.uio.no/sisu/SiSU/download#{@cX.off}

  For post installation help it is best you refer to '#{@cX.blue}man 8 sisu#{@cX.off}'

  Host
    host:             #{@cX.blue}#{@dir.hostname}#{@cX.off}
    arch:             #{@cX.blue}#{@dir.arch}#{@cX.off}
   
  Directories for installation
    bin:                                          #{@cX.blue}#{@dir.bin}#{@cX.off}
    lib (site-ruby):                              #{@cX.blue}#{Config::CONFIG['sitelibdir']}/#{SiSU_lib}#{@cX.off}
    conf [etc]:                                   #{@cX.blue}#{@dir.etc}/sisu/#{Version}#{@cX.off}
    data (document samples, images, README):      #{@cX.blue}#{@dir.sample_data}/sisu#{@cX.off}  and  #{@cX.blue}#{@dir.sample_data}/doc/sisu#{@cX.off}
    man (manual pages):                           #{@cX.blue}#{@dir.man}#{@cX.off}
    processing:                                   #{@cX.blue}#{@dir.processing}#{@cX.off}
    output www:                                   #{@cX.blue}#{@dir.data_o}#{@cX.off}

    Output files, are currently set to be produced in:
      processed document output:           #{@cX.blue}#{@dir.data_o}#{@cX.off}
      a document in the current directory  #{@cX.blue}#{Dir.pwd}#{@cX.off}
          will have its output placed in:  #{@cX.blue}#{@dir.data_o}/#@output_stub#{@cX.off}

  Install any additional programs of interest (that SiSU makes use of, that are not already on your system)

    Programs SiSU makes use of include:
      LaTeX
      texinfo
      pdfetex aka. pdflatex
      sqlite
      postgresql

  Again, refer to '#{@cX.blue}man 8 sisu#{@cX.off}'

  For additional help on using SiSU once installed type:
    
    sisu help

WOK
    end
    def setup
      print <<WOK

      [provide some setup information]

      also see http://www.jus.uio.no/sisu/SiSU  

WOK
    end
    def termsheet
      print <<WOK

  #{@cX.green}sisu -t [termsheetname].termsheet.rb#{@cX.off}
    will produce the collection of documents associated with [termsheetname.termsheet.rb]

  #{@cX.green}termsheet.rb#{@cX.off} files:
  (i) are named after the facility
  (ii) contain instructions as to which standard forms to use for the agreement (standard_form.rb)
     there may be several, eg. the termsheet, and the resulting: 
     main agreement; collection account charge; and deed of assignment
  (iii) contain the variable terms of the agreement, borrower, interest etc. 

  for a new loan agreement fill out a new termsheet specifying 
  what standard forms are to be used, 
  and the terms of the agreement.

  #{@cX.green}standard_form.rb#{@cX.off} files:
  contain the standard terms of the agreement
  there is a standard form for each variation of agreement 
    (so eg. there are as many facility agreements as there are variations in standard facility)
  these may be prepared for any agreement that is to be reused.
  (preparation takes the form of formating and 
  placing variable holders for the variables that are to be provided by the termsheet.rb file)

  it is necessary to purge the directory ~facilityData when old files are removed

WOK
    end
    def metaverse
      print <<WOK
    
    sisu -m [filename]    creates the metaverse, used by all other modules for downstream processing

WOK
    end
    def html
      print <<WOK
    
    sisu -h [filename]    html table version
    sisu -c [filename]    html css version
    sisu -L [filename]    html, links contian the filename suffix

WOK
    end
    def php
      print <<WOK
    
    sisu -z [filename]     php output, php extension, currently mostly html, but could take any php tags.

WOK
    end
    def latex
      print <<WOK
    
    sisu -p [filename]     produces pdf files from LaTeX output
                           produces LaTeX, which is used for pdf files (-l was taken by lout)

WOK
    end
    def texinfo
      print <<WOK

    sisu -i [filename]     produces texinfo and info files

    info and texinfo files are currently left in a separate work/output directory... have not decided what to do with them

    on my system info works fine point at file with info command

    pinfo, requires you to be within the work/output directory
      cd [work/output directory]

    and then to point at the file using 
      pinfo ./[filename]

WOK
    end
    def lout
      print <<WOK
    
    sisu -l [filename]

    lout broke while i was not been looking, and has not been maintained since :-(
    revisit someday

WOK
    end
      def tests
        print <<WOK
     
    sisu -T [test to run]

      (0|multi)                  multi test suite

      (1|multi_flag)             multi flag test

      (2|mh)                     test creation of metaverse and html output

      (3|h)                      test table version of html (metaverse skipped)

      (4|c|css)                  test css html (metaverse skipped)

      (5|z|php)                  test php output 

      (6|p|pdf)                  test pdf output

      (7|i|(tex)?info)           test texinfo

      (8|s|w(?:ord)?map)         test wordmap

      (9|q|term(sheet)?)         test termsheets

      (10|dbipg?sql)             test sql dbi

      (11|dbisqlite)             test sqlite dbi

      (12|(pg|postgres?)(sql)?)  test postgresql

      (13|sqlite)                test sqlite

      (14|s|spell)               test aspell

   look into these tests, modify, introduce more

WOK
    end
    def license
      
      print <<WOK

* License: GPL 2 or later

  #{@cX.ruby}GPL2 summary#{@cX.off}:
  
  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License
    #{@cX.blue}http://www.gnu.org/copyleft/gpl.html#{@cX.off}
  as published by the Free Software Foundation;
    #{@cX.blue}http://www.gnu.org/fsf/fsf.html#{@cX.off}
  either version 2 of the License, or (at your option)
  any later version.
  
  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
  more details.
  
  You should have received a copy of the GNU General Public License along
  with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
  
  If you have Internet connection, the latest version of the GPL should be
  available at these locations:
    #{@cX.blue}http://www.fsf.org/licenses/gpl.html#{@cX.off}
    #{@cX.blue}http://www.gnu.org/copyleft/gpl.html#{@cX.off}
    #{@cX.blue}http://www.jus.uio.no/sisu/gpl2.fsf#{@cX.off}

* see also the "SiSU Standard" section

* Ralph Amissah mailto:ralph@amissah.com
  Ralph Amissah mailto:ralph.amissah@gmail.com

WOK
    end
    def standards
      print <<WOK

SiSU uses:

*  Standard SiSU markup syntax,
*  Standard SiSU meta-markup syntax, and the
*  Standard SiSU object citation numbering and system

© Ralph Amissah 1997, current 2005.
All Rights Reserved.

Information on these may be obtained from:
  http://www.jus.uio.no/sisu

More information to be provided later.

* however note also the License section

* Ralph Amissah mailto:ralph@amissah.com
  Ralph Amissah mailto:ralph.amissah@gmail.com

WOK
    end
    def conversion
      print <<WOK
sisu_convert does the initial conversion from a couple of file formats to SiSU file format, currently only html and word97
  #{@cX.cyan}sisu_convert#{@cX.off} [keyword]
  sisu [keyword]
    #{@cX.green}--html#{@cX.off}       convert from html
    #{@cX.green}--pace#{@cX.off}       convert from html does some initial headers...
  ------------------------------------------
  Preparing Documents for SiSU
    #{@cX.green}--word97#{@cX.off}       sisu help markup     (an incomplete overview)
WOK
    end
    def external_programs
      puts <<WOK

    external ruby programs

    external programs
      #{@cX.cyan}pdf output - tex/latex#{@cX.off}
        #{@cX.orange}required#{@cX.off}
          tex-base/latex
          pdfetex aka. pdflatex
        #{@cX.brown}suggested/recommended#{@cX.off}
      #{@cX.cyan}db/sql output#{@cX.off}
        #{@cX.orange}required#{@cX.off}
          postgresql
        #{@cX.brown}suggested/recommended#{@cX.off}
          sqlite
      #{@cX.cyan}xml/xhtml/html output#{@cX.off}
        #{@cX.orange}required#{@cX.off}
        #{@cX.brown}suggested/recommended#{@cX.off}
          tidy  (xml, xhtml well formed check)
          trang (relaxng, rnc to dtd conversion)
WOK
    end
    def scratch
      print <<WOK
Types of tag, 

then there are various tags which occur within the document.
Structural tags, which consist of: 
  heading tags that identify headings within text, and; 
  footnote/endnote tags ... 

Markup instructions: giving information as to what is to be done to the presentation of the text

Markup tags

These have been kept to a minimum. A number of text html markup tags can be used <b>to bold</b> <i>to indent</i> <sup>for superscript</sup> <sub>for subscript text</sub>

_1 at the beginning of a line indents the paragraph

_2 at the beginning of a line double indents the paragraph

Others include 

Other things to note:

By default paragraphs are automatically numbered... and is the same across all output formats
This makes citation a lot easier... regardless of the form of output that is being looked at
It also permits the building of various addons, like the wordmap feature which identifies each word and the paragraphs in which the word appears with links to the paragraph...

Urls are automatically turned to live links in the html and pdf files created...
WOK
    end
  end
end
__END__

