=begin
 * Name: SiSU - Simple information Structuring Universe - Structured information, Serialized Units
 * Author: Ralph Amissah
   * http://www.jus.uio.no/sisu
   * http://www.jus.uio.no/sisu/SiSU/download

 * Description: LaTeX generation
   * arch-tag: latex for pdf (processing, logic) 
   * $Date$
   * $Id$
 * Copyright (C) 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005 Ralph Amissah

 * License: GPL 2 or later

  Summary of GPL 2

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along
  with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA

  If you have Internet connection, the latest version of the GPL should be
  available at these locations:
    http://www.fsf.org/licenses/gpl.html
    http://www.gnu.org/copyleft/gpl.html
    http://www.jus.uio.no/sisu/gpl2.fsf

  SiSU was first released to the public on January 4th 2005

  SiSU uses:
  
  *  Standard SiSU markup syntax,
  *  Standard SiSU meta-markup syntax, and the
  *  Standard SiSU object citation numbering and system
  
  © Ralph Amissah 1997, current 2005.
  All Rights Reserved.

 * Ralph Amissah: ralph@amissah.com
                  ralph.amissah@gmail.com
=end
module SiSU_Tex
  require 'pstore'
  $program||='tbl'
  require "#{SiSU_lib}/defaults"
  require "#{SiSU_lib}/param"
  include SiSU_Param
  include SiSU_Viz
  require "#{SiSU_lib}/texpdf_format"
  include SiSU_Tex_Pdf
  @tex_file=@@tex_footnote_array=@@tex_col_w=Array.new
  @@tex_backslash="\\\\"
  @@tex_3='\\\\\\{\\\\\\{' #?? debug crazy
  @@tex_1='\\\\\\~' #?? debug crazy
  @@tex_2='\\\\\\{\\\\\\{' #?? debug crazy
  @@tabular="{tabular}"
  @@column_instruct=@@squigle_close=@@tex_line_mode=@@tex_word_mode=@@line_mode=''
  @@tex_debug_counter=@@table_pagebreak_counter=@@tex_footnote_call_counter=@@tex_table_flag=@@tex_counter=@@tex_column=@@tex_columns=@@tex_columns=@@counting=0
  @@tex_pattern_margin_number="\\\\begin\\\{tiny\\\}~\\\\end\\\{tiny\\\}\\\{\\\\marginpar.+?\s+"
  #@@tex_pattern_margin_number="\\\\marginpar.+?\s+"
  @@n=@@tableheader=@@rights=nil
  @@date=SiSU_Env::Info_date.new
  class Source #Songsheet #<SiSU_Param::MyFiles
    $program='tbl'
    require 'pstore'
    require "#{SiSU_lib}/sysenv"
    require "#{SiSU_lib}/param"
    include SiSU_Env
    include SiSU_Param
    include SiSU_Viz
    require "#{SiSU_lib}/metaverse"
    include SiSU_Metaverse
    include SiSU_Tex
    def initialize(sf,cf)
      @fns,@cf=sf,cf
      @fnb=sf[/(.+?)\.[_-]?sst$/,1]
      @dir=SiSU_Env::Info_dir.new(@fns)
    end
    def directories
      begin
        @dir_out_root=@dir.data_o
        case @fns
        when /\.[_-]?sst$/
          Dir.mkdir(@dir.data_o) unless FileTest.directory?(@dir.data_o)
          Dir.mkdir(@dir.tex) unless FileTest.directory?(@dir.tex)
        end
      rescue: SiSU_Errors::Info_error.new($!,$@,@cf,@fns).error
      ensure
      end
    end
    def read
      songsheet
    end
    def songsheet
      begin
        @md=SiSU_Param::Parameters.new(@fns,@cf).get
        tell=SiSU_Screen::Ansi.new(@cf,'LaTeX/PDF')
        tell.greenTitleHi unless @cf =~/q/
        path=SiSU_Env::Info_dir.new(@fns).tell_output_location
        tell=SiSU_Screen::Ansi.new(@cf,@fns,"#{@dir.pdf_viewer} #{path}/#{@md.fnb}/#{@md.fn[:pdf_l]}")
        tell.flow if @cf =~/[MVv]/
        tell=SiSU_Screen::Ansi.new(@cf,@fns,"#{@dir.pdf_viewer} #{path}/#{@md.fnb}/#{@md.fn[:pdf_p]}")
        tell.flow if @cf =~/[MVv]/
        data=IO.readlines(@fns,'')                                             #wasteful, revisit
        @md=SiSU_Param::Parameters.new(@fns,@cf).get
        my_make=SiSU_Env::Create_file.new(@cf,@fns)
        if @md.flag_pdf
          $flag=@md.cf                                                         #introduced to pass 0 for no object citation numbers... to texpdf_format
          @dir_o="#{@dir.data_o}/#@fnb"
          directories
          @md.txt_path="#@dir_o/#@fnb"
          Dir.mkdir(@dir_o) unless FileTest.directory?(@dir_o)
          filename_index="#{@md.txt_path}/pdf"
          newfilename=filename_index
                                                                               #% needed needs to be reprogrammed !!!
          SiSU_Env::Info_skin.new(@md).select
          SiSU_Viz::Url.new
          metaverse_array=SiSU_Metaverse::Source.new(@fns,@cf).get             # metaverse file drawn here
          SiSU_Tex::Source::Tex_create.new(metaverse_array,@md,'landscape').songsheet
          SiSU_Tex::Source::Tex_create.new(metaverse_array,@md,'portrait').songsheet
          metaverse_array=''
          pwd=Dir.pwd
          SiSU_Tex::Source::LaTeX_to_pdf.new(@fns,@md).latexrun_selective
          Dir.chdir(pwd)
        else
          tell=SiSU_Screen::Ansi.new(@cf,'instructed NOT to produce LaTeX/PDF')
          tell.warn unless @cf =~/q/
        end
      rescue: SiSU_Errors::Info_error.new($!,$@,@cf,@fns).error
      ensure
        unless @cf =~/[MV]/ #check maintenance flag
          texfiles = Dir["#{@dir.tex}/#{@fns}*"]
          texfiles.each do |f| 
            if FileTest.file?(f)
              #puts "removing #{f}"
              File.unlink(f)
            end
          end
        end
        @tex_file=@@tex_footnote_array=Array.new
        @@column_instruct=''
        @@squigle_close=@@tex_line_mode=@@tex_word_mode=@@line_mode=''
        @@tex_debug_counter=@@table_pagebreak_counter=@@tex_footnote_call_counter=@@tex_table_flag=@@tex_counter=@@tex_column=@@tex_columns=@@tex_columns=@@counting=0
        @@tex_col_w=Array.new
        @@n=@@tableheader=@@rights=nil
        @@date=SiSU_Env::Info_date.new
        @@flag=Hash.new
        $flag=1 #remove at some stage
        SiSU_Env::Create_file.new(@cf,@fns).param_instantiate
      end
    end
    private
    class LaTeX_to_pdf #<Songsheet
      require 'fileutils'
      include FileUtils #::Verbose
      @@n_lpdf||=0 #change
      def initialize(fns,md)
        @fns,@md=fns,md
        @dir=SiSU_Env::Info_dir.new(@fns)
      end
      def latex_do(texfilename)
        @texfilename=texfilename
        @fnb=@md.fnb
        @@n_lpdf=@@n_lpdf+1
        tell=SiSU_Screen::Ansi.new(@md.cf,'portrait ->')
        tell.darkgreyTitleHi if @md.cf =~/[MVv]/
        tex_fn_base=@texfilename.gsub(/\.tex$/,'')
        cmd=SiSU_Env::System_call.new("#{tex_fn_base}.tex",'',@md.cf)
        tell=SiSU_Screen::Ansi.new(@md.cf)
        tell.greyOpen unless @md.cf =~/q/
        2.times { |i| cmd.latex2pdf unless ("#{tex_fn_base}.tex" !~/\w+/) }
        tell.p_off unless @md.cf =~/q/
        tell=SiSU_Screen::Ansi.new(@md.cf,'landscape ->')
        tell.darkgreyTitleHi if @md.cf =~/[MVv]/
        cmd=SiSU_Env::System_call.new("#{tex_fn_base}.landscape.tex",'',@md.cf)
        tell.greyOpen
        2.times { |i| cmd.latex2pdf unless ("#{tex_fn_base}.landscape.tex" !~/\w+/) }
        tell.p_off unless @md.cf =~/q/
        pwd=Dir.pwd
        #fns_l=@fns.gsub(/~/,'-') #this is a sorry fix, but necessary as it appears latex programs like not ~
        portrait_pdf="#{pwd}/#{tex_fn_base}.pdf"
        landscape_pdf="#{pwd}/#{tex_fn_base}.landscape.pdf"
        if FileTest.file?(portrait_pdf)
          File.install(portrait_pdf,"#@dir_sisu/#{@fnb}/#{@md.fn[:pdf_p]}")
          File.unlink(portrait_pdf)
        end
        if FileTest.file?(landscape_pdf)
          File.install(landscape_pdf,"#@dir_sisu/#{@fnb}/#{@md.fn[:pdf_l]}")
          File.unlink(landscape_pdf)
        end
        tell=SiSU_Screen::Ansi.new(@md.cf,@@n_lpdf,'processed (SiSU LaTeX to pdf - using pdfetex aka. pdftex or pdflatex)')
        tell.genericNumber unless @md.cf =~/q/
      end
      def latexrun_selective
        begin
          ep_dir=Dir.pwd
          Dir.chdir(ep_dir)
          @tex_f_no=0
          info=Hash.new
          @fns.each do |file|
            if FileTest.file?("#{ep_dir}/#{file}")
              if file =~/\.[_-]?sst$/
                @dirout=SiSU_Env::Info_dir.new(@fns)
                case file
                when /\.[_-]?sst$/
                  if FileTest.directory?(@dir.tex)==true
                    Dir.chdir(@dir.tex)
                    @dir_sisu=@dirout.data_o
                    texfile=file.gsub(/$/,'.tex')
                    texfile=texfile.gsub(/~/,'-')
                    if File.exists?(texfile) and File.size(texfile) > 0
                      @tex_f_no+=1
                      latex_do(texfile)
                    else
                      puts "\tzero file size #{@dir.tex}/#{file}"
                    end
                  end
                end
              end
            else
              puts "\n#{@cX.fuschia}FILE NOT FOUND:#{@cX.off} << #{file} >> - requested latex system processing skipped\n"
            end
          end
          lst=Dir["*.{aux,log,out}"]
          lst.each {|file| File.unlink(file)} if lst
          #touch("#{@dir_pdf}index.html") #correct @dir_pdf appears to contain slash / and should not
        rescue: SiSU_Errors::Info_error.new($!,$@,@fns,@md.cf).error
        end
      end
    end
    class Tex_create
      include SiSU_Param
      @@tex_backslash="\\\\"
      @@tex_3='\\\\\\{\\\\\\{' #?? debug crazy
      @@tex_1='\\\\\\~' #?? debug crazy
      @@tex_2='\\\\\\{\\\\\\{' #?? debug crazy
      @@tex_head_portrait=Array.new
      @@tex_head_landscape=Array.new
      @@flag_group,@@flag_code=false,false
      @@prefix_b=nil
      def initialize(data,md,orientation)
        @data,@md,@orientation=data,md,orientation
        @fns=@md.fns
        @fnb=@fns[/(.+?)\.[_-]?sst$/,1]
        @dir=SiSU_Env::Info_dir.new(@fns)
        @vz=Hash.new
        @vz[:tex]=Hash.new
        @tex=SiSU_Tex_Pdf::SoloTex.new(@orientation,@md)
        @url=SiSU_Viz::Url.new
        @txt=SiSU_Viz::Txt.new
      end
      def songsheet
        begin
          @@tex_footnote_array=Array.new #check
          SiSU_Viz::Url.new
          data=@data
          @@rights=nil
          tell=SiSU_Screen::Ansi.new(@md.cf,"pdfTex #@orientation")
          tell.txt_grey unless @md.cf =~/q/
          if @md.dc_rights
            use=@md.dc_rights.dup #dup is necessary, else contents of :rights changed
            doMono=SiSU_Tex_Pdf::MonoTex.new(use,@md)
            copymark=if @md.creator_copymark: '{\\begin{small}\\raisebox{1ex}{\\copyright}\\end{small}} '
            else ''
            end
            copyright=doMono.special_characters_safe.gsub(/^\s*Copyright/, copymark)
            @@rights||="\n #{@@tex_backslash*2}[3]\\ \\linebreak #{copyright}"
          end
          if @md.prefix_b
            doMono=SiSU_Tex_Pdf::MonoTex.new(@md.prefix_b,@md)
            prefix_b=doMono.special_characters_safe
            @@prefix_b="\n #{@@tex_backslash*2}[3]\\ \\linebreak \\ #{prefix_b}\n" unless @@prefix_b
          end
          if @md.markup.to_s !~/url_png/
            munge=Tex_create.new(@data,@md,@orientation).pre
            munge=Tex_create.new(munge.collect,@md,@orientation).footnote
            if @md.flag_tables
              munge=Tex_create.new(munge.collect,@md,@orientation).tables
            end
            munge=Tex_create.new(munge.collect,@md,@orientation).numbering
            munge=Tex_create.new(munge.collect,@md,@orientation).markup
            Tex_create.new(munge.collect,@md,@orientation).output
          end
        rescue: SiSU_Errors::Info_error.new($!,$@,@fns,@md.cf).error
        ensure
        end
      end
    protected
      def pre
        @tex_file=Array.new
        data=@data
        data.each do |para|
          # DEBUG 2003w16 this is a kludge, because i could not get parameters
          # from param, Sort out ... revert to more elegant solution
          # even more of a kludge as had to insert newlines where code is used not satisfactory, think about 
          pg=if para =~/<:br>/: para.split(/<:br>/)
          else                   para
          end
          pg.each do |pg|
          if pg =~/<!Th?¡\s+c/i: @md.flag_tables=true # KLUDGE get from param
          end
          doMono=SiSU_Tex_Pdf::MonoTex.new(pg,@md)
          @tex_file << doMono.special_characters
          end
        end
        data=@tex_file.delete_if {|x| x =~/^\s*0#{@@tex_1}/}
        @tex_file
      end
      def footnote
        data=@data.dup
        @tex_file=Array.new
        data.each do |para|
          para2=para.dup
          if para2 =~/(?:-#{@@tex_2}\\~\d+|<!e\\_\d+!>)/
            para2.gsub!(/(?:-#{@@tex_2}\\~\d+|<!e\\_\d+!>)/, ' ')  # \\1
            para2.chomp!
            @@tex_footnote_array << para2
          end
          # EMBEDDED FOOTNOTES / ENDNOTES should be straightforward but not quite a synch.
          # BUG bug -> have problems with endnotes in headers
          footnote=Array.new
          #if para =~/~\\\{\d+\s+/ # note escape not necessary in front of ~ has implications for many other matches #debug note
          #  para.gsub!(/\\\~\\\{(\d+)\s+(.+?)\\\}\\\~/m, "\\footnote[\\1]{%\n\\smallskip{} \\noindent \\2} ") #removed space before \\footnote 2004w21, watch
          #end
          #p para if para =~/~\\\{\d+\s+/
          if para =~/~\\\{\d+\s+/                                                # note escape not necessary in front of ~ has implications for many other matches #debug note
            para.gsub!(/\\\~\\\{(\d+)\s+(.+?)<[0-9a-f]{32}>\\\}\\\~/m, "\\footnote[\\1]{%\n \\2} ") #removed space before \\footnote 2004w21, watch
          end
          @tex_file << para
        end
        @tex_file
      end
      def tables
        data=@data
        @tex_file=Array.new
        @@tableheader=0
        data.each do |para|
          if para =~/¡|<!T/i
            do_mono=SiSU_Tex_Pdf::MonoTex.new(para,@md)
            para=do_mono.longtable_landscape if @orientation =~/landscape/ # using longtable latex package
            para=do_mono.longtable_portrait if @orientation =~/portrait/ # using longtable latex package
          end
          @tex_file << para 
        end
      end
      def tables_portrait
        data=@data
        @tex_file=Array.new
        @@tableheader=0
        data.each do |para|
          if para =~/¡|<!T/i
            doMono=SiSU_Tex_Pdf::MonoTex.new(para,@md)
          end
          @tex_file << para 
        end
      end
      def enclose(para,type='')
        para.strip!
        if type =~/code/: para
          #para = '\begin{footnotesize} \begin{ttfamily} ' + para + ' \end{ttfamily} \end{footnotesize}'
        elsif para !~/(\\begin\{tabular\}.*|\\end\{tabular\}|&|#{@@tex_backslash*2})\s*$/ #check
          para.gsub!(/(.+)/mi, "\n#{@tex.skip_small} \\1 #{@tex.skip_small}\n")
        else para
        end
      end
      def markup
        data=@data
        @tex_file=Array.new
        md=Hash.new
                                                                                 #% document headers watch special characters in title & subtitle: glark "\{\{~(sub)?title.+?[$&%#_\{\}]" *.(lm|er)??  
        home=@txt.home.gsub(/<(br|p)>|<\/\s*(br|p)>|<(br|p)\s*\/>|\\\\/i, " - ") #no line splitting in heading neither html nor latex
        title=@md.title.gsub(/<(br|p)>|<\/\s*(br|p)>|<(br|p)\s*\/>|\\\\/i, " - ") #no line splitting in heading neither html nor latex 
        subtitle=@md.subtitle.gsub(/<(br|p)>|<\/\s*(br|p)>|<(br|p)\s*\/>|\\\\/i, " - ") if @md.subtitle #no line splitting in heading neither html nor latex
        @duotex=SiSU_Tex_Pdf::Format_text_object.new(@orientation,"#{home}: - #{title} #{subtitle}", @md) #.new
        if @orientation =~/portrait/
          @@tex_head_portrait << @duotex.a4_orientation 
        elsif @orientation =~/landscape/
          @@tex_head_landscape << @duotex.a4_orientation
        end
        @tex_file <<<<WOK
#{@tex.header}#{@tex.footer}
\\makeatother
\\makeatother
\\begin{document}
WOK
        sisu_rc_footnote=if @md.rc_info: @tex.doc_rc_info_footnote_full
        else                             @tex.doc_rc_info_footnote_brief
        end
        #@copymark='{\\begin{small}\\raisebox{1ex}{\\copyright}\\end{small}}'
        @copymark=if @md.creator_copymark: '^\copyright'
        else                               ''
        end
        if @orientation =~/landscape/ # using longtable latex package
          @tex_file << SiSU_Tex_Pdf::Format_text_object.new(@md.title,@md.subtitle,@md).title_landscape
          if @md.dc_creator
            doMono=SiSU_Tex_Pdf::MonoTex.new(@md.dc_creator,@md)
            creator=doMono.special_characters
            @tex_file << if @md.creator_home
              <<WOK

\\author{\\href{#{@md.creator_home}}{#@copymark \\textnormal{#{creator}}}}
WOK
            else "\n\\author{#@copymark \\textnormal{#{creator}}}" 
            end
          end
          @tex_file << unless @md.fnb =~/^mail\s*$/
            "\n\\date{copy @ #{@tex.site} #{sisu_rc_footnote}}"
          else "\\date"
          end
        else #portrait
          @tex_file << SiSU_Tex_Pdf::Format_text_object.new(@md.title,@md.subtitle,@md).title_portrait
          if @md.dc_creator
            creator=@md.dc_creator
            @tex_file << if @md.creator_home
              <<WOK

\\author{\\href{#{@md.creator_home}}{#@copymark \\textnormal{#{creator}}}}
WOK
            else "\n\\author{#@copymark \\textnormal{#{creator}}}" 
            end
           end
          @tex_file << unless @md.fnb =~/^mail\s*$/: "\n\\date{copy @ #{@tex.site} #{sisu_rc_footnote}}"
          else                                       "\\date"
          end
        end
        @tex_file <<<<WOK
\\pagenumbering{roman}\\maketitle
\\pagestyle{fancy}
WOK
        @tex_file << "\\newpage\n"
        @tex_file << @@rights if @md.dc_rights #if @orientation =~/landscape/
        @tex_file << @@prefix_b if @md.prefix_b
        @tex_file << @tex.sisu_rights
        @tex_file << if @md.rc_info: @tex.doc_rc_info
        else                         @tex.doc_no_rc_info
        end
        @tex_file << @tex.newpage 
        @tex_file <<<<WOK
\\pagestyle{fancy}
\\tableofcontents
#{@tex.newpage}
\\pagenumbering{arabic}
#{@tex.paraskip_normal}
WOK
        @tex_file << @tex.newpage 
        @group_collect=Array.new
        data.each do |para|                                                      #% case follows with levels 1-6 indents & graphics
          mono=SiSU_Tex_Pdf::MonoTex.new(para,@md)
          if para =~/<:(code|alt|poem|group)>/ or @@flag_group==true
            if para =~/<:(code|alt|poem|group)>/
              @lineone=case para 
              when /<:(alt|poem|group)>/: para 
              when /<:code>/: "#{@tex.paraskip_small} \\begin{footnotesize} \\begin{ttfamily} " + para
              else 'error' #should never occur
              end
            end
            regx=/<:((?:code|alt|poem|group)(?:-end)?)>/
            x=regx.match(para)[1] if para =~regx
            x=$1
            para.gsub!(/\n<:(?:code|alt|poem|group)>\n/m,'')
            para=enclose(para,'code') unless para =~/^$/
            if x =~/(?:alt|poem|group)/: @@flag_group=true
            elsif x =~/code/: @@flag_group,@@flag_code=true,true
            elsif @@flag_group==true:    @group_collect << para #<< "\n\n"
            end
            if x =~/(?:code|alt|poem|group)-end/
              regx=/(\\+marginpar\{\\+begin\{tiny\}\d+\\+end\{tiny\}\})/ 
              y=if para =~regx: regx.match(para)[1] 
              else ''
              end
              para.gsub!(regx,'')
              @group_collect.each{ |x| x.gsub!(/(.#{@@tex_1}(?:\S+)?\s*|<:\S+>|<!.*?!>|<!>)/, ' ') }
              @lineone.gsub!(/(.#{@@tex_1}(?:\S+)?\s*|<:\S+>|<!.*?!>|<!>)/, ' ')
              insert=Array.new
              if para =~/<:code-end>/
                insert << y + @lineone << @group_collect << ' \end{ttfamily} \end{footnotesize}' << " #{@tex.paraskip_normal}"
              else insert << y + @lineone << @group_collect
              end
              @@flag_group,@@flag_code=false,false
              @group_collect=Array.new
              para.gsub!(/(.#{@@tex_1}(?:\S+)?\s*|<:\S+>|<!.*?!>|<!>)/, ' ')
              @tex_file << insert.flatten
            end
          else
            case para
            when /^1#{@@tex_1}/:       mono.level1
            when /^2#{@@tex_1}/:       mono.level2
            when /^3#{@@tex_1}/:       mono.level3
            when /^4#{@@tex_1}/:       mono.level4
            when /^5#{@@tex_1}/:       mono.level5
            when /^6#{@@tex_1}/:       mono.level6
            when /^<:i1>/:             mono.indent1 
            when /^<:i2>/:             mono.indent2
            when /<:=/:                mono.symbol_graphic #watch
            when /^\s*<:image\s+/:     mono.image
            when /\}image/:            mono.png
            when /\}(?:https?|ftp)/
              para=mono.http
              para=enclose(para)
            else
              para.strip!
              para=enclose(para) unless para =~/^$/
            end
            para.gsub!(/(\.#{@@tex_1}(?:\S+)?\s*|<:\S+>|<!.*?!>|<!>)/, ' ')   #% tread with care
            #para.gsub!(/(.#{@@tex_1}(?:\\~\S+)?\s*|<:\S+>|<!.*?!>|<!>)/, ' ')  #KEEP reference, problem escaping open curly braces \{
            @tex_file << para
          end
        end
        @tex_file << "\n\\newpage\n" # was \\pagebreak\n
          #@md[:title_tex]=@md[:title].dup
        @md.subtitle_tex=@md.subtitle.dup if @md.subtitle
        # kludge ... look again later
        @tex_file << if @md.doc_skin !~/skin_mail/: @tex.doc_tail 
        else                                        @tex.mail_tail
        end
        if defined? @md.lnk and @md.lnk
          @md.lnk.each do |l|
            if l[:say]
              url=%<#{l[:url]}>
              url.gsub!(/(?:\\)*([$&~%_#}{^])/, "\\\\\\1")                         #latex special chars
              s_lnk=l[:say]
              s_lnk.gsub!(/(<br>|<br \/>|<p>|<p \/>)/i, '')
              s_lnk.gsub!(/(?:\\)*([$&~%_#}{^])/, "\\\\\\1")                       #latex special chars
              if url !~/^\.(\.)?\//
                s_lnk_url=%<\\begin{scriptsize}\\href{#{url}}{#{url}}\\end{scriptsize}>  # note this bit of dereferencing magic
              else
                url.gsub!(/\.\.\//, '')
                s_lnk_url="(#{@tex.site}) \\\\\n" + ' ' +
                  "\\begin{scriptsize}" +
                  %<\\href\{#{@url.root_http}/#{url}\}\{#{@url.root_http}/#{url}\}> + # note this bit of dereferencing magic
                  "\\end{scriptsize}"
              end
              @tex_file << " #{s_lnk} \\\\\n #{s_lnk_url} \n" unless  @md.doc_skin =~/skin_mail/
              s_lnk=s_lnk_url=nil
            end
          end
        end
        @tex_file << " #{@tex.sitename} home: \\\\ 
\\begin{bfseries}#{@tex.site}\\end{bfseries}
"
        #Stamp.stamp #removed 200408 but watch
                                                                                 #% code for inclusion of addresses of promulgating authority
        @vz[:tex][:stmp]||=@md.stmpd
        stamp=@vz[:tex][:stmp] if @vz[:tex][:stmp]
        if stamp
          use=stamp.gsub(/\n/,"#{@@tex_backslash*2}\n")
          @tex_file << "\n\\newpage\n"
          @tex_file << "\\section*" +
            "{#{@tex.owner_chapter}}\n" +
            "\\addcontentsline{toc}" +
            "{section}{#{@tex.owner_chapter}}\n"
          @tex_file << "#{use}\n"
          @tex_file << @@rights if @@rights
        end
        @tex_file << "\n\\end{document}"
      end
      def footnote_call_number
        data=@data
        data.each do |word|
          if word =~/<:e>/
            @@tex_footnote_array[@@tex_footnote_call_counter].strip!  if @@tex_footnote_array[@@tex_footnote_call_counter]
            word.gsub!(/<:e>/,
              " \\footnote{%\n #{@@tex_footnote_array[@@tex_footnote_call_counter]}} ")
            @@tex_footnote_call_counter+=1
          end
        end
      end
      def numbering
        data=@data
        data=Tex_create.new(data,@md,@orientation).number_titles
        #TOGGLE to SWITCH PARAGRAPH NUMBERING (ON & OFF)
        Tex_create.new(data,@md,@orientation).number_paras if @md.markup !~/not_to/i
      end
      def number_titles
        data=@data
        @tex_file=Array.new
        input=%{#{@md.markup}}[/(num_top\s*=\s*(\d?))?/m, 2] # else default usually 4  # this was a bit of a trick required to pass nil to input if nothing matched... #puts input
        num_top=input.to_i
        t_no1=t_no2=t_no3=t_no4=0
        no1,no2,no3,no4=num_top,(num_top + 1),(num_top + 2),(num_top + 3);
        data.each do |para|
          if @md.markup =~/num_top/i and para !~/0#{@@tex_1}/
            if para =~/[1-6]#{@@tex_1}(?:\S+)?\s*<!h-.+?-!>/ and para !~/<:\d-endnotes>/i
              header=para[/<!h-(.+?)-!>/im, 1].gsub!(/-/m, ".")
              para.gsub!(/[1-6]#{@@tex_1}(?:\S+)\s*<!h-.+?-!>/i, "\\1 #{header} ")
            end
          elsif para =~/<!h!>|<!h\d!>|<!h.+?!>|<!!h.+?!>/i
            if para =~/<!h-.+?-!>/i: para.gsub!(/<!h-(.+?)-!>/i, "\\1 ")
            end
          end
          @tex_file << para
        end
        @tex_file
      end
      def number_paras
        data=@data
        @tex_file=Array.new
        paranumber=0
        data.each do |para|
          if para =~/<\\~(\d+);(?:[oh]|[0-6]:)\d+;\w\d+><[0-9a-f]{32}:[0-9a-f]{32}>/ and para !~/\\end\{longtable\}|<EOF>/ #catch <!TZ!>
            m=/(.+?)<\\~(\d+);(?:[oh]|[0-6]:)\d+;\w\d+><[0-9a-f]{32}:[0-9a-f]{32}>/im
            parablock=para[m, 1]
            paranum=para[m, 2]
            do_duo=SiSU_Tex_Pdf::Format_text_object.new(parablock,paranum,@md)
            para=do_duo.paraNum if parablock
          elsif para =~/^<~\d+;(?:[oh]|[0-6]:)\d+;\w\d+><[0-9a-f]{32}:[0-9a-f]{32}>/ #2005 this is added for tables, rationalise
            m=/<~(\d+);(?:[oh]|[0-6]:)\d+;\w\d+><[0-9a-f]{32}:[0-9a-f]{32}>/im
            paranum=para[m,1]
            para.gsub!(/<~\d+;(?:[oh]|[0-6]:)\d+;\w\d+><[0-9a-f]{32}:[0-9a-f]{32}>/,'')
            para="\\marginpar{\\begin{tiny}#{paranum}\\end{tiny}}" + para
          #elsif para =~/<!T.+?!~\d+?>/
          elsif para =~/^<~\d+;(?:[oh]|[0-6]:)\d+;\w\d+>/ #extra 2005 this is added for tables, rationalise
            m=/<~(\d+);[oh]\d+;\w\d+>/im
            paranum=para[m, 1]
            para.gsub!(/<~\d+;(?:[oh]|[0-6]:)\d+;\w\d+>/,'')
            para="\\marginpar{\\begin{tiny}#{paranum}\\end{tiny}}" + para
          elsif para =~/\\end\{longtable\}/ #catch <!TZ!>
            para.gsub!(/<\\~\d+>|<\\~(\d+);(?:[ohm]|[0-6]:)\d+;\w\d+><[0-9a-f]{32}:[0-9a-f]{32}>/,'')
            para.gsub!(/<\\~\d+>|<\\~(\d+);(?:[ohm]|[0-6]:)\d+;\w\d+>/,'') #extra
          end
          @tex_file << para
        end
        @tex_file
      end
      def output
        data=@data
        @tex_file=Array.new
        data.flatten!
        data.compact!
        data.each do |para|
          para.gsub!(/^\s+/, '')
          @tex_file << para
        end
        fns_l=@fns.gsub(/~/,'-') #this is a sorry fix, but necessary as it appears latex programs like not ~
        if @orientation =~/landscape/    #@tex_file << "\n<!EOF!>"
          filename_tex_landscape=File.new("#{@dir.tex}/#{fns_l}.landscape.tex",'w+')
          filename_tex_landscape << @@tex_head_landscape 
          @tex_file.each {|para| filename_tex_landscape.puts para, "\n" unless para.empty?}
          filename_tex_landscape.close
          @@tex_head_landscape=Array.new
        elsif @orientation =~/portrait/
          filename_tex_portrait=File.new("#{@dir.tex}/#{fns_l}.tex",'w+')
          filename_tex_portrait << @@tex_head_portrait
          @tex_file.each {|para| filename_tex_portrait.puts para, "\n" unless para.empty?} 
          filename_tex_portrait.close
          @@tex_head_portrait=Array.new
        end
        @tex_file=Array.new
      end
    end
  end
end
__END__
